<?php
/*
 * Created on 10.11.2008
 *
 */
require_once 'System.php';
require_once(dirname(__FILE__).'/include/constants.php');
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/functions.php');
require_once(dirname(__FILE__).'/include/fileserver.php');

function convertVoiceFile($filename, $filetitle) {
	global $logger;
	$logger->log("convertVoiceFile($filename, '$filetitle')", PEAR_LOG_INFO);

	$rec_artist = '';
	$rec_title = '';
	if (strpos($filetitle, '|') > 0) {
		list(,$rec_artist, $rec_title) = explode('|', $filetitle, 3);
	}
	if (strlen($rec_artist) == 0) {
		$rec_artist = ' ';
		$rec_title = $filetitle;
	}

	$outfile = System::mktemp('aout_');
	$cnvt = AUDIO_CONVERT_CALL_FMT;
	$cnvt = str_ireplace('%infile%', $filename, $cnvt);
	$cnvt = str_ireplace('%outfile%', $outfile, $cnvt);
	$cnvt = str_ireplace('%artist%', $rec_artist, $cnvt);
	$cnvt = str_ireplace('%title%', $rec_title, $cnvt);
	$logger->log("convertVoiceFile($filename)->$cnvt", PEAR_LOG_INFO);
	exec($cnvt);
	return $outfile;
}

function sendVoiceFile($filename, $filetitle = '', $filemode = '!save') {
	global $logger;
	$logger->log("sendVoiceFile($filename, '$filetitle')", PEAR_LOG_INFO);

	if (strpos($filetitle, '|') > 0) {
		list($rec_type, $rec_date, $rec_title) = explode('|', $filetitle, 3);
		$outfilename = $rec_date . ' ' . $rec_title . '.mp3';
	} else
		$outfilename = empty($filetitle) ? $filename : $filetitle . '.mp3';

	header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
	header('Cache-Control: no-store, no-cache, must-revalidate');
	header('Cache-Control: post-check=0, pre-check=0', FALSE);
	header('Pragma: no-cache');
	header('Content-Type: audio/mpeg');
	header('Content-Length: ' . filesize($filename));
	if ($filemode == 'save') {
		header('Content-Disposition: attachment; filename="' . $outfilename . '";size=' . filesize($filename));
		header('Content-Transfer-Encoding: binary');
		header('Content-Description: File Transfer');
	}

	$res = false;
	ob_start();
	if (($fp = fopen($filename, 'r'))) {
		while (!feof($fp)) {
			$buff = fread($fp, 4096);
			print $buff;
		}
		fclose($fp);
		$logger->log("sendVoiceFile($filename, '$filetitle', '$filemode') -> SENT ".filesize($filename)." bytes", PEAR_LOG_INFO);
		$res = true;
	} else
		$logger->log("sendVoiceFile($filename, '$filetitle', '$filemode') -> OPENING ERROR", PEAR_LOG_ERR);
	ob_end_flush();
	flush();
	return $res;
}

global $session, $logger;
//$logger->log("REQUEST(".basename($_SERVER['SCRIPT_NAME']).":\n".print_r($_REQUEST, true), PEAR_LOG_DEBUG);
//$logger->log("session->db_ok:".print_r($session->db_ok, true), PEAR_LOG_DEBUG);
//$logger->log("session->logged_in:".print_r($session->logged_in, true), PEAR_LOG_DEBUG);

if ($session->logged_in && isset($_REQUEST['id'])) {
	global $fileserver_control;

	$fileid = $_REQUEST['id'];
	$filetitle = (isset($_REQUEST['ttl']) && !empty($_REQUEST['ttl'])) ? base64_decode($_REQUEST['ttl']) : $fileid;
	$filetitle = trim($filetitle);
	$filemode = (isset($_REQUEST['m']) && ($_REQUEST['m'] == 'save')) ? 'save' : '';

	//$logger->log('ttl='.iconv('utf-8', 'cp1251//IGNORE', $filetitle), PEAR_LOG_DEBUG);

	$file = System::mktemp('ain_');
	//$fileserver_control->DebugMode=true;
	$res = $fileserver_control->ReceiveFile($fileid, $file);
	$logger->log("ReceiveFile($fileid) -> $res", PEAR_LOG_INFO);
	if ($res == FS_ERROR_OK) {
		$file = convertVoiceFile($file, /*$fileid,*/ $filetitle);
		if (is_readable($file) && filesize($file) > 0)
			sendVoiceFile($file, $filetitle, $filemode);
		else
			sendVoiceFile(AUDIO_ERROR_FILESERVER, 'Error - File Not Found', $filemode);
	} else
		sendVoiceFile(AUDIO_ERROR_FILESERVER, 'Error - File Not Found', $filemode);
} else {
	$logger->log("getfile({$_REQUEST['id']}) -> " . AUDIO_ERROR_NOTAUTHORIZED, PEAR_LOG_ALERT);
	sendVoiceFile(AUDIO_ERROR_NOTAUTHORIZED, 'Error - Not Authorized');
}
?>
