<?php
require_once 'System.php';
require_once(dirname(__FILE__).'/include/constants.php');
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/database.php');
require_once(dirname(__FILE__).'/include/database_dynmenu.php');
require_once(dirname(__FILE__).'/include/functions.php');
require_once(dirname(__FILE__).'/include/fileserver.php');

$uploadErrors = array(
	UPLOAD_ERR_INI_SIZE		=> 'Размер файла превышает максимально разрешенный размер для загрузки на сервере',//'The uploaded file exceeds the upload_max_filesize directive in php.ini.',
	UPLOAD_ERR_FORM_SIZE	=> 'Размер файла превышает максимально разрешенный размер для загрузки на клиенте',//'The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form.',
	UPLOAD_ERR_PARTIAL		=> 'Файл загружен не полностью',//'The uploaded file was only partially uploaded.',
	UPLOAD_ERR_NO_FILE		=> 'Не выбран файл для загрузки',//'No file was uploaded.',
	UPLOAD_ERR_NO_TMP_DIR	=> 'На сервере отсутствует временная директория',//'Missing a temporary folder.',
	UPLOAD_ERR_CANT_WRITE	=> 'Ошибка при размещении файла на сервере',//'Failed to write file to disk.',
	UPLOAD_ERR_EXTENSION	=> 'Загрузка файла прервана на сервере'//'File upload stopped by extension.'
);

$arrRes = array(
	'files' => $_FILES['synthz_add_file'],
	'description' => $_POST['synthz_add_file_description']
);

function prepareVoiceFileForFileServer($filename, $fileismpeg = false) {
	global $logger;

	$outfile = System::mktemp('aout_');
	$cnvt = AUDIO_CONVERT_CALL_FMT_SAVE;
	$cnvt = str_ireplace('%infile%', $filename, $cnvt);
	$cnvt = str_ireplace('%outfile%', $outfile, $cnvt);
	unlink($outfile);
	$res = exec($cnvt);
	$logger->log("prepareVoiceFileForFileServer($filename)->$cnvt:$res");

	if (is_readable($outfile) && filesize($outfile) > 0) {
		$logger->log("prepareVoiceFileForFileServer($filename)->".filesize($outfile));
		return $outfile;
	}

	if ($fileismpeg) {
		$logger->log("prepareVoiceFileForFileServer($filename)->PROBLEM1->Trying to convert as MPEG");
		$cnvt = AUDIO_CONVERT_CALL_FMT_SAVE_MPEG;
		$cnvt = str_ireplace('%infile%', $filename, $cnvt);
		$cnvt = str_ireplace('%outfile%', $outfile, $cnvt);
		if (file_exists($outfile))
			unlink($outfile);
		$res = exec($cnvt);
		$logger->log("prepareVoiceFileForFileServer($filename, MPEG)->$cnvt:$res");

		if (is_readable($outfile) && filesize($outfile) > 0) {
			$logger->log("prepareVoiceFileForFileServer($filename, MPEG)->".filesize($outfile));
			return $outfile;
		}
	}

	$logger->log("prepareVoiceFileForFileServer($filename)->PROBLEM->Returning source file as result");
	return $filename;
}

function sendDataFile($filename, $filetitle = '') {
	global $logger;
	$logger->log("sendDataFile($filename, '$filetitle')");

	$outfilename = empty($filetitle) ? $filename : $filetitle . '.mp3';

	header('Content-Description: File Transfer');
	header('Content-Type: audio/mpeg');
	header('Content-Disposition: attachment; filename="' . $outfilename . '"');  //basename($filename)
	header('Content-Transfer-Encoding: binary');
	header('Expires: 0');
	header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
	header('Pragma: public');
	header('Content-Length: ' . filesize($filename));

	ob_clean();
	flush();

	if (($fp = fopen($filename, 'r'))) {
		while (!feof($fp)) {
			$buff = fread($fp, 4096);
			print $buff;
		}
		fclose($fp);
		return true;
	}
	return false;
}

global $logger, $session;
//$logger->log("REQUEST(".basename($_SERVER['SCRIPT_NAME']).":\n".print_r($_REQUEST, true));
$logger->log("SYN_UPLOAD:\n".$arrRes['description']."\n".print_r($arrRes['files'], true));

if ($session->logged_in) {
	global $database_dynmenu, $fileserver_control;

	$mode = isset($_POST['uploadtype']) ? $_POST['uploadtype'] : 'synth';
	$menuid = isset($_POST['mid']) ? $_POST['mid'] : -1;

	if ($arrRes['files']['error'] !== UPLOAD_ERR_OK) {
		$arrRes['status'] = 'error';
		$arrRes['error'] = isset($uploadErrors[$arrRes['files']['error']]) ? $uploadErrors[$arrRes['files']['error']] : 'Неизвестная ошибка при загрузке файла';
	} elseif (($arrRes['files']['name'] == '') || ($arrRes['files']['size'] <= 0)) {
		$arrRes['status'] = 'error';
		$arrRes['error'] = 'Файл не задан или пуст';
	} elseif (($file = System::mktemp('aup_')) && move_uploaded_file($arrRes['files']['tmp_name'], $file)) {
		//sleep(5);
		$fileid = null;
		switch ($mode) {
			case 'synth':
				$file = prepareVoiceFileForFileServer($file, preg_match('/audio\/mpeg/i', $arrRes['files']['type']));
				break;
		}
		$res = $fileserver_control->PlaceFile($file, $fileid, false, true);
		if ($res == FS_ERROR_OK) {
			switch ($mode) {
				case 'synth':
					$filedescription = empty($arrRes['description']) ? 'Без названия' : $arrRes['description'];
					$database_dynmenu->addSynth($fileid, 1, $menuid, $filedescription);
					break;
			}
			$arrRes['status'] = 'ok';
			$arrRes['fileid'] = $fileid;
		} else {
			$arrRes['status'] = 'error';
			switch ($fileserver_control->ErrorDesc) {
				case 'error 133':
					$arrRes['error'] = 'Неизвестный формат файла';
					break;
				case 'error 134':
					$arrRes['error'] = 'Ошибка конвертации файла во внутренний формат';
					break;
				default:
					$arrRes['error'] = 'Внутренняя ошибка FS: ' . $fileserver_control->ErrorDescription($res);
					break;
			}
		}
	} else {
		$arrRes['status'] = 'error';
		$arrRes['error'] = 'Внутренняя ошибка';
	}
} else {
	$arrRes['status'] = 'error';
	$arrRes['error'] = 'Ошибка авторизации';
}

print '<textarea>'.json_encode_safe($arrRes).'</textarea>';

?>
