<?php
require_once(dirname(__FILE__) . '/include/session.php');
require_once(dirname(__FILE__) . '/include/database.php');

global $session, $database;
if (!$session->db_ok) {
	print('database not ok');
	die();
}
if (!$session->logged_in) {
	print('Вы не авторизованы.');
	die();
}

function get_projstats_data() {
	global $database, $logger;

	$totalcnt = 0;
	$project_snapshot = $database->get_project_snapshot_params($_REQUEST['pid'], $_REQUEST['sf_projsnapshot']);
	$tasks = $database->get_project_task_list($_REQUEST['pid'],
		$project_snapshot['starttm'], $project_snapshot['endtm'], $project_snapshot['is_complete'] ? 1 : null,
		1, 1000000, null, null, null, null, $totalcnt);
	//counts
	$graphdata = array('total_cnt' => 0,
		'done_cnt' => 0,
		'done_1' => 0,
		'done_2' => 0,
		'done_3' => 0,
		'done_4' => 0,
		'done_5' => 0,
		'done_6' => 0,
		'done_7' => 0,
		'done_8' => 0,
		'done_9' => 0,
		'done_10' => 0,
		'failed_cnt' => 0,
		'failed_u' => 0,
		'failed_i' => 0);
	$graphdata['total_cnt'] = count($tasks);
	foreach ($tasks as $task) {
		switch ($task['tm_task_status']) {
			case TMS_STATUS_DIAL_PAUSE:
			case TMS_STATUS_STOP_DIAL_LIMIT:
			case TMS_STATUS_TECH_BLOCK:
				$graphdata['failed_cnt']++;
				$graphdata['failed_u']++;
				break;
			case TMS_STATUS_STOP_BLOCKING:
			case TMS_STATUS_COMPLETE:
				if ($task['tm_task_result'] == TMR_STATUS_CONFIRM) {
					$graphdata['done_cnt']++;
					$graphdata['done_' . $task['tm_task_try_count']]++;
				} else {
					$graphdata['failed_cnt']++;
					$graphdata['failed_i']++;
				}
				break;
			default:
				$graphdata['failed_cnt']++;
				break;
		}
	}

	//procents
	$prcval = 100 / $graphdata['total_cnt'];
	$graphdata_prc = array();
	foreach ($graphdata as $pname => $pvalue)
		$graphdata_prc[$pname . '_prc'] = round($pvalue * $prcval);
	$graphdata = array_merge($graphdata, $graphdata_prc);

	//times
	$timedata = array('done_cnt_tm' => 0,
		'done_1_tm' => 0,
		'done_2_tm' => 0,
		'done_3_tm' => 0,
		'done_4_tm' => 0,
		'done_5_tm' => 0,
		'done_6_tm' => 0,
		'done_7_tm' => 0,
		'done_8_tm' => 0,
		'done_9_tm' => 0,
		'done_10_tm' => 0,
		'failed_cnt_tm' => 0,
		'failed_u_tm' => 0,
		'failed_i_tm' => 0);
	foreach ($tasks as $task) {
		$tm = intval($task['tm_task_wait_answer_time']) + intval($task['tm_task_talk_time']);
		switch ($task['tm_task_status']) {
			case TMS_STATUS_DIAL_PAUSE:
			case TMS_STATUS_STOP_DIAL_LIMIT:
			case TMS_STATUS_TECH_BLOCK:
				$timedata['failed_cnt_tm'] += $tm;
				$timedata['failed_u_tm'] += $tm;
				break;
			case TMS_STATUS_STOP_BLOCKING:
			case TMS_STATUS_COMPLETE:
				if ($task['tm_task_result'] == TMR_STATUS_CONFIRM) {
					$timedata['done_cnt_tm'] += $tm;
					$timedata['done_' . $task['tm_task_try_count'] . '_tm'] += $tm;
				} else {
					$timedata['failed_cnt_tm'] += $tm;
					$timedata['failed_i_tm'] += $tm;
				}
				break;
			default:
				$timedata['failed_cnt_tm'] += $tm;
				break;
		}
	}
	$graphdata = array_merge($graphdata, $timedata);

	$logger->log("get_projstats_data:" . print_r($graphdata, true), PEAR_LOG_DEBUG);

	return $graphdata;
}

function get_projdetail_data() {
	global $database;

	$graphdata = array('fresh' => 0, 'needretry' => 0, 'done' => 0, 'failed' => 0);

	$totalcnt = 0;
	$project_snapshot = $database->get_project_snapshot_params($_REQUEST['pid'], $_REQUEST['sf_projsnapshot']);
	//ToDo: if dates are not required $ptaskinfo = $database->get_project_tasks_info($_GET['pid'], 'null');
	$tasks = $database->get_project_task_list($_REQUEST['pid'],
		$project_snapshot['starttm'], $project_snapshot['endtm'], $project_snapshot['is_complete'] ? 1 : null,
		1, 1000000, null, null, null, null, $totalcnt);
	foreach ($tasks as $task) {
		switch ($task['tm_task_status']) {
			case TMS_STATUS_DIAL_PAUSE:
				$graphdata['needretry']++;
				break;
			case TMS_STATUS_STOP_DIAL_LIMIT:
			case TMS_STATUS_TECH_BLOCK:
				$graphdata['failed']++;
				break;
			case TMS_STATUS_STOP_BLOCKING:
			case TMS_STATUS_COMPLETE:
				$graphdata['done']++;
				break;
			default:
				/*case TMS_STATUS_READY_FOR_DIAL:
				case TMS_STATUS_INSERTED:
				case TMS_STATUS_UPDATED:
				case TMS_STATUS_WAIT_FOR_DIAL:
				case TMS_STATUS_DIALING:*/
				$graphdata['fresh']++;
				break;
		}
	}

	return $graphdata;
}

function generate_projdetail_graph($skipheader = false) {
	require_once(dirname(__FILE__) . '/include/pchart/pdata.php');
	require_once(dirname(__FILE__) . '/include/pchart/pchart.php');
	require_once(dirname(__FILE__) . '/include/pchart/pcache.php');

	$chart_dataset = new pData;
	//$chart_dataset->AddPoint(array(intval($_REQUEST['pid']), 2, 3, 5), 'data');
	$gdata = get_projdetail_data();
	$chart_dataset->AddPoint(array($gdata['fresh'], $gdata['needretry'], $gdata['done'], $gdata['failed']), 'data');
	$chart_dataset->AddPoint(array('Необработано', 'Требуется повторный вызов', 'Обслужено', 'Необслужено'), 'captions');
	$chart_dataset->AddAllSeries();
	$chart_dataset->SetAbsciseLabelSerie('captions');

	$chart_cache = new pCache('graph_cache/');
	//$chart_cache->GetFromCache('graph_projdetail', $chart_dataset->GetData());
	if (!$chart_cache->IsInCache('graph_projdetail', $chart_dataset->GetData())) {
		$chart = new pChart(690, 250);
		$chart->drawFilledRoundedRectangle(4, 4, 686, 246, 2, 240, 240, 240);
		$chart->drawRoundedRectangle(2, 2, 688, 248, 2, 230, 230, 230);

		//$chart->createColorGradientPalette(195, 204, 56, 223, 110, 41, 4);
		$chart->setColorPalette(0, 204, 204, 204);
		$chart->setColorPalette(1, 50, 183, 226);
		$chart->setColorPalette(2, 51, 223, 123);
		$chart->setColorPalette(3, 234, 55, 50);

		$chart->setFontProperties(dirname(__FILE__) . '/include/pchart/fonts/tahoma.ttf', 8);
		$chart->AntialiasQuality = 0;
		//$chart->ShadowActive = true;
		//$chart->ShadowAlpha = 10;
		//$chart->ShadowBlur = 10;
		$chart->drawPieGraph($chart_dataset->GetData(), $chart_dataset->GetDataDescription(), 250, 120, 110, PIE_PERCENTAGE, true, 80, 20, 12);
		$chart->drawPieLegend(506, 8, $chart_dataset->GetData(), $chart_dataset->GetDataDescription(), 250, 250, 250);

		$chart->setFontProperties(dirname(__FILE__) . '/include/pchart/fonts/tahoma.ttf', 10);
		$chart->drawTitle(10, 20, 'Детализация по проекту', 100, 100, 100);

		$chart_cache->WriteToCache("graph_projdetail", $chart_dataset->GetData(), $chart);
	}

	//Header("Content-type: image/png");
	//$chart->Render('');

	if (!$skipheader)
		Header('Content-type: text/html; charset=UTF-8');
	$img = $chart_cache->GetHash('graph_projdetail', $chart_dataset->GetData());
	echo "<img src='graph_cache/{$img}.png' alt=''/>";

	return true;
}

function generate_projstats_graph($skipheader = false) {
	require_once(dirname(__FILE__) . '/include/pchart/pdata.php');
	require_once(dirname(__FILE__) . '/include/pchart/pchart.php');
	require_once(dirname(__FILE__) . '/include/pchart/pcache.php');

	$chart_dataset = new pData;
	//$chart_dataset->AddPoint(array(intval($_GET['pid']), 2, 3, 5), 'data');
	$gdata = get_projstats_data();
	$chart_dataset->AddPoint(array(
		$gdata['done_1'],
		$gdata['done_2'],
		$gdata['done_3'],
		$gdata['done_4'],
		$gdata['done_5'],
		$gdata['done_6'],
		$gdata['done_7'],
		$gdata['done_8'],
		$gdata['done_9'],
		$gdata['done_10'],
		$gdata['failed_u'], $gdata['failed_i']
	), 'data');
	$chart_dataset->AddPoint(array(
		'Обслуженные с 1-го раза',
		'Обслуженные со 2-го раза',
		'Обслуженные с 3-го раза',
		'Обслуженные с 4-го раза',
		'Обслуженные с 5-го раза',
		'Обслуженные с 6-го раза',
		'Обслуженные с 7-го раза',
		'Обслуженные с 8-го раза',
		'Обслуженные с 9-го раза',
		'Обслуженные с 10-го раза',
		'Неотвеченные', 'Отверженные'
	), 'captions');
	$chart_dataset->AddAllSeries();
	$chart_dataset->SetAbsciseLabelSerie('captions');

	$chart_cache = new pCache('graph_cache/');
	//$chart_cache->GetFromCache('graph_projstats', $chart_dataset->GetData());
	if (!$chart_cache->IsInCache('graph_projstats', $chart_dataset->GetData())) {
		$chart = new pChart(690, 250);
		$chart->drawFilledRoundedRectangle(4, 4, 686, 246, 2, 240, 240, 240);
		$chart->drawRoundedRectangle(2, 2, 688, 248, 2, 230, 230, 230);

		//$chart->createColorGradientPalette(51, 223, 123, 234, 55, 50, 12);
		$chart->createColorGradientPalette(0, 230, 0, 230, 0, 0, 12);

		$chart->setFontProperties(dirname(__FILE__) . '/include/pchart/fonts/tahoma.ttf', 8);
		$chart->AntialiasQuality = 0;
		$chart->drawPieGraph($chart_dataset->GetData(), $chart_dataset->GetDataDescription(), 250, 120, 110, PIE_PERCENTAGE, true, 80, 20, 12);
		$chart->drawPieLegend(517, 8, $chart_dataset->GetData(), $chart_dataset->GetDataDescription(), 250, 250, 250);

		$chart->setFontProperties(dirname(__FILE__) . '/include/pchart/fonts/tahoma.ttf', 10);
		$chart->drawTitle(10, 20, 'Статистика по проекту', 100, 100, 100);

		$chart_cache->WriteToCache("graph_projstats", $chart_dataset->GetData(), $chart);
	}

	//Header("Content-type: image/png");
	//$chart->Render('');

	if (!$skipheader)
		Header('Content-type: text/html; charset=UTF-8');
	$img = $chart_cache->GetHash('graph_projstats', $chart_dataset->GetData());
	echo "<img src='graph_cache/{$img}.png' alt=''/>";

	return true;
}

switch ($_REQUEST['gtype']) {
	case 'detail':
		generate_projdetail_graph();
		break;

	case 'stats':
		generate_projstats_graph(true);
		break;

	default:
		echo 'Запрошен неизвестный тип графика.';
}

//get_projstats_data();

?>
