<?php
/**
 * database_dynmenu.php
 * Created on 13.04.2009
 *
 */
require_once(dirname(__FILE__).'/constants_dynmenu.php');
require_once(dirname(__FILE__).'/session.php');
require_once 'MDB2.php';
//PEAR::setErrorHandling(PEAR_ERROR_DIE);
//PEAR::setErrorHandling(PEAR_ERROR_PRINT);
PEAR::setErrorHandling(PEAR_ERROR_RETURN);

/**
 * getPEARErrorInfo - Returns full info from PEAR::Error
 */
if (!function_exists('getPEARErrorInfo')) {
	function getPEARErrorInfo($dberrobj, $sep = "\n") {
		if (PEAR::isError($dberrobj)) {
			$dbmsg = $dberrobj->getUserInfo();
			$dbmsgd = $dberrobj->getDebugInfo();
			$dbmsgd = (strcmp($dbmsg, $dbmsgd) == 0) ? '' : $sep . "dbg: " . $dbmsgd;
			return "msg: " . $dberrobj->getMessage() . "(" . $dberrobj->getCode() . ")" . $sep
			       . "dbgmsg: " . $dbmsg . $dbmsgd;
		} else {
			return "";
		}
	}
}

function db_debug_handler(&$db, $scope, $message, $is_manip = null) {
	global $logger;
	$res = MDB2_defaultDebugOutput($db, $scope, $message, $is_manip);
	$logger->log('dbdebug:'.print_r($res, true));
	return $res;
}

class DYNMENUDB {
	public $connection;
	public $db_ok;

	function DYNMENUDB() {
		global $logger;

		/* Make connection to database */
		$dsn = DB_ENGINE_DYNMENU.'://'.DB_USER_DYNMENU.':'.DB_PASS_DYNMENU.'@'.DB_HOST_DYNMENU.'/'.DB_FILE_DYNMENU;
		$this->connection =& MDB2::factory($dsn, false);
		if (PEAR::isError($this->connection)) {
			$this->db_ok = false;
			$logger->log("IBDB Fatal Error:\n".getPEARErrorInfo($this->connection, "\n"), PEAR_LOG_CRIT);
			return;
		}
		$this->db_ok = true;

		//$this->connection->setOption('debug', true);
		//$this->connection->setOption('debug_handler', 'db_debug_handler');
		$this->connection->setOption('field_case', CASE_LOWER);
		$this->connection->setOption('portability', MDB2_PORTABILITY_NUMROWS | MDB2_PORTABILITY_FIX_CASE);
		$this->connection->setFetchMode(MDB2_FETCHMODE_ASSOC);
		//$this->connection->setFetchMode(MDB2_FETCHMODE_OBJECT);
		$this->connection->LoadModule('Extended');

//		$logger->log("ibase.timestampformat BEFORE=".ini_get("ibase.timestampformat"));
//		if (function_exists('ibase_timefmt')) {
//			ibase_timefmt("%d.%m.%Y", IBASE_TIMESTAMP);
//			ibase_timefmt("%d.%m.%Y", IBASE_DATE);
//		} else {
//			ini_set("ibase.timestampformat", "%d.%m.%Y");
//			//ini_set("ibase.timeformat", "%H:%M:%S");
//			ini_set("ibase.dateformat", "%d.%m.%Y");
//		}
//		$logger->log("ibase.timestampformat AFTER=".ini_get("ibase.timestampformat"));
	}

	function transactionStart() {
		return true;

		/*global $logger;

		$result = false;
		if (true/*$this->connection->supports('transactions')* /) {
				$result = $this->connection->beginTransaction();
		}
		$logger->log("transactionStart=\n".print_r($result, true));
		return $result;*/
	}

	function transactionCommit() {
		return true;

		/*global $logger;

		$result = false;
		if (true/*$this->connection->inTransaction()* /) {
			$result = $this->connection->commit();
		}
		$logger->log("transactionCommit=\n".print_r($result, true));
		return $result;*/
	}

	function transactionRollback() {
		return true;

		/*global $logger;

		$result = false;
		if (true/*$this->connection->inTransaction()* /) {
			$result = $this->connection->rollback();
		}
		$logger->log("transactionRollback=\n".print_r($result, true));
		return $result;*/
	}

	/**
	 * query - Performs the given query on the database and
	 * returns the result resource
	 */
	function query($query) {
		return $this->connection->query($query);
	}

	/**
	 * prepare - wrapper
	 */
	function prepare($query, $types) {
		global $logger;

		$result = $this->connection->prepare($query, $types);
		if (PEAR::isError($result)) {
			$logger->log("prepare($query, $types) ERR:\n".getPEARErrorInfo($result), PEAR_LOG_ERR);
			return null;
		}
		return $result;
	}

	/**
	 * execute - wrapper
	 */
	function execute($preparedquery, $data) {
		global $logger;

		$result = $preparedquery->execute($data);

		if (PEAR::isError($result)) {
			$logger->log("execute ERR:".getPEARErrorInfo($result), PEAR_LOG_ERR);
			return null;
		}
		$res = $result->fetchAll();
		$result->free();
		return $res;
	}

	/**
	 * getProcResultAsArray
	 */
	function getQueryResultAsArray($query, $singleton = false, $types = null) {
		global $logger;

		$result = $this->connection->queryAll($query, $types);
		if (PEAR::isError($result)) {
			$logger->log("getQueryResultAsArray($query) ERR:\n" . getPEARErrorInfo($result), PEAR_LOG_ERR);
			$result = null;
		}
		//$logger->log("getQueryResultAsArray($query) RES:\n" . print_r($result, true), PEAR_LOG_DEBUG);

		if ($singleton === false)
			return $result;
		else {
			if (empty($result))
				return null;
			else
				return $result[0];
		}
	}

	/**
	 * getUserEditableSynths - gets user editable synths list.
	 * Returns array or null in case of failure.
	 */
	function getUserEditableSynths($menuid) {
		return $this->getQueryResultAsArray("select * from menu_get_items_usereditable($menuid)");
	}

	/**
	 * setItemSynths - sets synths list for single voice item.
	 * Returns int or null in case of failure.
	 */
	function setItemSynths($itemid, $synthz) {
		return $this->getQueryResultAsArray("select * from menu_set_item_synth($itemid, '$synthz')", true);
	}

	function getSynthsList($menuid,
		$page = 1, $resultsperpage = 99999,
		$sortname = null, $sortorder = null,
		$searchname = null, $searchquery = null,
		&$totalcnt) {

		if (!$sortname)
			$sortname = 'id';
		if (!$sortorder)
			$sortorder = 'desc';
		$sort = "order by $sortname $sortorder";

		if (!$page)
			$page = 1;
		if (!$resultsperpage)
			$resultsperpage = 30;
		$start = ($page - 1) * $resultsperpage;
		$limit = "first $resultsperpage skip $start";

		$addwhere = "";
		if ($searchquery) {
			$addwhere = "and $searchname like ";
			$addwhere .= (substr($searchquery, 0, 1) == '^') ?
					"'" . substr($searchquery, 1) . "%'" :
					"'%$searchquery%'";
		}

		$cntres = $this->getQueryResultAsArray("select count(*) from menu_get_synthez_list($menuid)", true);
		$totalcnt = empty($cntres) ? 0 : $cntres['count'];

		if ($totalcnt > 0)
			return $this->getQueryResultAsArray("select $limit * from menu_get_synthez_list($menuid) $addwhere $sort");
		else
			return array();

		//return $this->getQueryResultAsArray("select * from menu_get_synthez_list($menuid)");
	}

	/**
	 * addSynth - Registers global synth in the database.
	 * Returns new synth info or NULL in case of failure.
	 * @param $synth_id
	 * @param $place
	 * @param $menuid
	 * @param $synth_description
	 * @return array|null
	 */
	function addSynth($synth_id, $place, $menuid, $synth_description) {
		global $logger;

		$q = "select * from menu_add_synthez('$synth_id', $place, $menuid, '".$this->connection->escape($synth_description)."')";
		$result = $this->connection->query($q);
		if (PEAR::isError($result)) {
			$logger->log("database->addSynth($q):ERR\n" . getPEARErrorInfo($result), PEAR_LOG_ERR);
			return null;
		}

		if ((!$dbarray = $result->fetchRow()) || !$dbarray['id'])
			return null;

		return $dbarray;
	}

	/**
	 * deleteSynth - Deletes global synth from the database.
	 * Returns deleted synth info or NULL in case of failure.
	 */
	function deleteSynth($synth_id, $place, $menuid) {
		global $logger;

		$q = "select * from menu_del_synthez('$synth_id', $place, $menuid)";
		$result = $this->connection->query($q);
		if (PEAR::isError($result)) {
			$logger->log("database->deleteSynth($q):ERR\n" . getPEARErrorInfo($result), PEAR_LOG_ERR);
			return null;
		}

		if ((!$dbarray = $result->fetchRow()) || !$dbarray['id'])
			return -1;

		return $dbarray['res'];
	}

	/**
	 * getMenuInfo - Gets menu description by menuid.
	 * Returns "" in case of failure.
	 */
	function getMenuInfo($menuid) {
		global $logger;

		$q = "select * from menu_get_name($menuid)";
		$result = $this->connection->query($q);
		if (PEAR::isError($result)) {
			$logger->log("$q:\n".getPEARErrorInfo($result), PEAR_LOG_ERR);
			return null;
		}

		if((!$dbarray = $result->fetchRow()) || !$dbarray['menu_name'])
			return '';

		return $dbarray['menu_name'];
	}

	/**
	 * getMenusList - Gets menu list in 'array' format.
	 * Returns null in case of failure.
	 */
	function getMenuList() {
		global $logger;

		$q = 'select * from menu_get_menus_list';
		$result = $this->getQueryResultAsArray($q);
		if (PEAR::isError($result)) {
			$logger->log("getMenusList:ERR=\n".getPEARErrorInfo($result), PEAR_LOG_ERR);
			return null;
		} else
			return $result;
	}

	/**
	 * getMenusListAsOfficeOption - Gets menu list in 'office option' format.
	 * Returns "" in case of failure.
	 */
	function getMenuListAsOfficeOption($arr_menus) {
		$str = '-1|Сценарий не выбран';
		if (empty($arr_menus))
			return $str;
		foreach ($arr_menus as $menu) {
			if ($str != '')
				$str .= ',';
			$str .= $menu['menu_id'].'|'.$menu['menu_name'];
		}
		return $str;
	}

	/**
	 * cloneMenu - clones specified menu.
	 * Returns new menu id or null
	 */
	function cloneMenu($in_menuid, $in_menuname) {
		global $logger;

		if ($in_menuid == null || $in_menuname == null)
			return null;

		$pq = $this->prepare("select * from global_menu_duplicate($in_menuid, ?)",
								array('text'));
		$result = $this->execute($pq, array($in_menuname));
		if (PEAR::isError($result))
			$logger->log("cloneMenu($in_menuid, '$in_menuname'):ERR=\n".getPEARErrorInfo($result), PEAR_LOG_ERR);

		$result = (empty($result) || PEAR::isError($result)) ? null : $result[0]['out_menu_id'];
		return $result;
	}

	/**
	 * logMenuChange - Logs change event to database.
	 * Returns false or code from database :)
	 */
	function logMenuChange($log_changetype, $log_menu_id, $log_userdata, $log_msg) {
		global $session, $logger;

		//changelog
		$log_office_user_id = $session->logged_in ? $session->userid : -1;
		$log_msg .= $session->logged_in ? " Пользователь '{$session->username}' (id:{$session->userid})." : "";

		$q = "select * from menu_changelog_log($log_changetype, $log_menu_id, $log_office_user_id, $log_userdata, " .
			"'".$this->connection->escape($log_msg)."')";
		$result = $this->connection->query($q);
		if (PEAR::isError($result)) {
			$logger->log("$q:\n".getPEARErrorInfo($result), PEAR_LOG_ERR);
			return false;
		}

		if((!$dbarray = $result->fetchRow()) || !$dbarray['out_res']) {
			return false;
		}

		return $dbarray['out_res'];
	}

	/**
	 * getChangelog - Gets change event list from database.
	 * Returns false or code from database :)
	 */
	function getChangelog($log_menu_id) {
		$q = 'select first '.MAX_CHANGELOG_ROWS." * from tb_changelog_menus where log_menu_id=$log_menu_id order by log_time descending";
		$result = $this->getQueryResultAsArray($q);
		if ($result) {
			function sortbydate_menus($r1, $r2) {
				return (strtotime($r1['log_time']) < strtotime($r2['log_time'])) ? -1 : 1;
			};
			usort($result, 'sortbydate_menus');
		}
		return $result;
	}

};

$database_dynmenu = new DYNMENUDB;

?>
