<?php
require_once 'System.php';
require_once(dirname(__FILE__).'/constants.php');
require_once(dirname(__FILE__).'/functions.php');

$uploadErrors = array(
	UPLOAD_ERR_INI_SIZE		=> 'Размер файла превышает максимально разрешенный размер для загрузки на сервере',//'The uploaded file exceeds the upload_max_filesize directive in php.ini.',
	UPLOAD_ERR_FORM_SIZE	=> 'Размер файла превышает максимально разрешенный размер для загрузки на клиенте',//'The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form.',
	UPLOAD_ERR_PARTIAL		=> 'Файл загружен не полностью',//'The uploaded file was only partially uploaded.',
	UPLOAD_ERR_NO_FILE		=> 'Не выбран файл для загрузки',//'No file was uploaded.',
	UPLOAD_ERR_NO_TMP_DIR	=> 'На сервере отсутствует временная директория',//'Missing a temporary folder.',
	UPLOAD_ERR_CANT_WRITE	=> 'Ошибка при размещении файла на сервере',//'Failed to write file to disk.',
	UPLOAD_ERR_EXTENSION	=> 'Загрузка файла прервана на сервере'//'File upload stopped by extension.'
);

function prepareVoiceFileForFileServer($filename, $fileismpeg = false) {
	global $logger;

	$outfile = System::mktemp('aout_');
	$cnvt = AUDIO_CONVERT_CALL_FMT_SAVE;
	$cnvt = str_ireplace('%infile%', $filename, $cnvt);
	$cnvt = str_ireplace('%outfile%', $outfile, $cnvt);
	unlink($outfile);
	$res = exec($cnvt);
	$logger->log("prepareVoiceFileForFileServer($filename)->$cnvt:$res");

	if (is_readable($outfile) && filesize($outfile) > 0) {
		$logger->log("prepareVoiceFileForFileServer($filename)->".filesize($outfile));
		return $outfile;
	}

	if ($fileismpeg) {
		$logger->log("prepareVoiceFileForFileServer($filename)->PROBLEM1->Trying to convert as MPEG");
		$cnvt = AUDIO_CONVERT_CALL_FMT_SAVE_MPEG;
		$cnvt = str_ireplace('%infile%', $filename, $cnvt);
		$cnvt = str_ireplace('%outfile%', $outfile, $cnvt);
		if (file_exists($outfile))
			unlink($outfile);
		$res = exec($cnvt);
		$logger->log("prepareVoiceFileForFileServer($filename, MPEG)->$cnvt:$res");

		if (is_readable($outfile) && filesize($outfile) > 0) {
			$logger->log("prepareVoiceFileForFileServer($filename, MPEG)->".filesize($outfile));
			return $outfile;
		}
	}

	$logger->log("prepareVoiceFileForFileServer($filename)->PROBLEM->Returning source file as result");
	return $filename;
}
?>
