<?php
function format_money($summ) {
	return number_format($summ, 2, '.', '');
}

function format_duration($dur) {
	//$days = intval(($dur / 60 / 60 / 24) % 60);
	$hours = intval(($dur / 60 / 60) % 60);
	$minutes = intval(($dur / 60) % 60);
	$seconds = intval($dur % 60);

	$res = str_pad($minutes, 2, "0", STR_PAD_LEFT) .":". str_pad($seconds, 2, "0", STR_PAD_LEFT);
	if ($hours > 0)
		$res = $hours .":". $res;

	return $res;
}

function format_seconds($seconds) {
	$minutes = floor($seconds / 60);
	$seconds_left = $seconds % 60;

	$hours = floor($minutes / 60);
	$minutes_left = $minutes % 60;

	$days = floor($hours / 24);
	$hours_left = $hours % 24;

	$res = str_pad($minutes_left, 2, "0", STR_PAD_LEFT) .":". str_pad($seconds_left, 2, "0", STR_PAD_LEFT);
	if ($hours_left > 0)
		$res = $hours_left .":". $res;
	if ($days > 0)
		$res = $days .":". $res;

	return $res;
}

function adjustlinebreaks($text) {
	return preg_replace("/\r\n|\n|\r/", "\r\n", $text);
}

function utf8_encode_safe($text) {
	return $text;
	/*$enc = mb_detect_encoding($text, 'UTF-8, Windows-1251', true);
	return ($enc == false || $enc == 'UTF-8') ? $text : iconv($enc, 'utf-8//TRANSLIT', $text);*/
}

//http://ru2.php.net/manual/en/function.json-encode.php#72450
//http://ru2.php.net/manual/en/function.json-encode.php#73854
define('DEFAULT_CHARSET', 'cp1251');

function json_encode_safe($var) {
	return json_encode(json_fix_cyr($var));
}

function json_fix_cyr($var) {
	if (is_array($var)) {
		$new = array();
		foreach ($var as $k => $v) {
			$new[json_fix_cyr($k)] = json_fix_cyr($v);
		}
		$var = $new;
	} elseif (is_object($var)) {
		$vars = get_obj_vars($var);
		foreach ($vars as $m => $v) {
			$var->$m = json_fix_cyr($v);
		}
	} elseif (is_string($var)) {
		//$var = iconv(DEFAULT_CHARSET, 'utf-8', $var);
	}
	return $var;
}

function stripslashes_deep(&$value) {
	$value = is_array($value) ?
				array_map('stripslashes_deep', $value) :
				stripslashes($value);
	return $value;
}

function handle_magic_quotes() {
	if ((function_exists("get_magic_quotes_gpc") && get_magic_quotes_gpc()) ||
		(ini_get('magic_quotes_sybase') && (strtolower(ini_get('magic_quotes_sybase')) != "off"))) {
		stripslashes_deep($_GET);
		stripslashes_deep($_POST);
		stripslashes_deep($_COOKIE);
	}
}

?>
