var pbookctrl = '';

function close_all() {
	var res = false;
	var dlgs = new Array('#dialogprojectprops, #dialogprojectstat, #dialogtaskstats, #dialogtaskprops, #dialogtasksload');
	$.each(dlgs, function(idx, dlg){
		if ($(dlg).overlay().isOpened()) {
			res = true;
			$(dlg).overlay().close();
		}
	});
	return res;
}

function show_auth() {
	if ($('#dialogauth').overlay().isOpened())
		return false;

	if (close_all()) {
		setTimeout('show_auth();', 200);
		return false;
	}

	$('#shutter').show();
	if ($('#dialogauth').children().length <= 1) {
		ui_block();
		$("#dialogauth").load('widget_auth', function() {
			ui_unblock();
			$(this).show('fast');
			$('#authlogin').focus();
		});
	} else
		$('#dialogauth').overlay().load();
	return false;
}

function show_tasksload(projectid) {
	if ($('#dialogtasksload').overlay().isOpened())
		return false;

	if ($('#dialogtasksload').children().length <= 1) {
		ui_block();
		$("#dialogtasksload").load('widget_tasksload', function() {
			ui_unblock();
			updateTasksLoad(projectid);
			$(this).show('fast');
		});
	} else {
		updateTasksLoad(projectid);
		$('#dialogtasksload').overlay().load();
	}
	return false;
}

function show_projectstats(projectid) {
	if ($('#dialogprojectstat').overlay().isOpened())
		return false;

	if ($('#dialogprojectstat').children().length <= 1) {
		ui_block();
		$("#dialogprojectstat").load('widget_projectstat', function() {
			ui_unblock();
			updateProjStats(projectid);
			$(this).show('fast');
		});
	} else {
		updateProjStats(projectid);
		$('#dialogprojectstat').overlay().load();
	}
	return false;
}

function show_taskstats(taskid) {
	if ($('#dialogtaskstats').overlay().isOpened())
		return false;

	if ($('#dialogtaskstats').children().length <= 1) {
		ui_block();
		$("#dialogtaskstats").load('widget_taskstats', function() {
			ui_unblock();
			updateTaskStats(taskid);
			$(this).show('fast');
		});
	} else {
		updateTaskStats(taskid);
		$('#dialogtaskstats').overlay().load();
	}
	return false;
}


function show_taskprops(taskid) {
	if ($('#dialogtaskprops').overlay().isOpened())
		return false;

	if ($('#dialogtaskprops').children().length <= 1) {
		ui_block();
		$("#dialogtaskprops").load('widget_taskprops', function() {
			ui_unblock();
			updateTaskProps(taskid);
			$(this).show('fast');
		});
	} else {
		updateTaskProps(taskid);
		$('#dialogtaskprops').overlay().load();
	}
	return false;
}

function show_projectprops(projectid) {
	if ($('#dialogprojectprops').overlay().isOpened())
		return false;

	if ($('#dialogprojectprops').children().length <= 1) {
		ui_block();
		$("#dialogprojectprops").load('widget_projectprops', function() {
			ui_unblock();
			updateProjectProps(projectid);
			$(this).show('fast');
		});
	} else {
		updateProjectProps(projectid);
		$('#dialogprojectprops').overlay().load();
	}
	return false;
}

function FilterSetDateInterval(dti, startname, endname) {
	var now = new Date();
	var dt = new Date();
	switch (dti) {
		case 'w':
			dt.addDays(-7);
			break;
		case 'm':
			dt.addMonths(-1);
			break;
		case '2m':
			dt.addMonths(-2);
			break;
		case '05y':
			dt.addMonths(-6);
			break;
		case 'y':
			dt.addYears(-1);
			break;
	}
	$('#' + startname).dpSetSelected(dt.asString());
	$('#' + endname).dpSetSelected(now.asString());
	return true;
}

$(document).ready(function() {
	$('#dialogauth').overlay({expose: {
			color: '#333',
			loadSpeed: 200,
			opacity: 0.9
		},
		top: 37,
		closeOnClick: false,
		closeOnEsc: false
	});

	$('#dialogtaskstats, #dialogtaskprops, #dialogtasksload, #dialogprojectprops, #dialogprojectstat').overlay({expose: {
			color: '#333',
			loadSpeed: 0,
			opacity: 0.9
		},
		top: 10,/*37*/
		closeOnClick: true,
		closeOnEsc: true
	}).bind('onBeforeLoad', function(event) {
		timer_projects_stop();
	}).bind('onClose', function(event) {
		timer_projects_start();
	});

	$('input[type="image"]').attr('disabled', true).addClass('disabled');

	update_all();
});
