<?php
require_once(dirname(__FILE__) . '/include/constants.php');
require_once(dirname(__FILE__) . '/include/functions.php');
require_once(dirname(__FILE__) . '/include/session.php');
require_once(dirname(__FILE__) . '/include/database.php');
require_once(dirname(__FILE__) . '/include/fileserver.php');
require_once(dirname(__FILE__) . '/include/fileserver_tools.php');
require_once 'Text/Password.php';

class Process {
	private $jsonres = array();

	function Process() {
		global $session, $logger;

		//$logger->log("[logged_in=".var_export($session->logged_in,true)."]".'process:post=' . print_r($_POST, true));

		if (isset($_POST['op'])) {
			$this->jsonres = array(
				'op' => $_POST['op'],
				'auth' => $session->logged_in
			);

			if (!$session->logged_in && !in_array($_POST['op'], array('auth', 'deauth'))) {
				$this->jsonres['error'] = 'NotAuthorized!';
				$this->jsonres['page'] = 1;
				$this->jsonres['rows'] = array();
				$this->jsonres['total'] = 0;

				$this->int_send_array_as_json($this->jsonres);
				//$logger->log("process:error=not authorized [logged_in=".var_export($session->logged_in,true)."]");
			} else
				switch ($_POST['op']) {
					case 'auth':
						$this->proc_login();
						break;
					case 'deauth':
						$this->proc_logout();
						break;
					case 'check_status':
						$this->proc_check_status();
						break;

					case 'project_filters_set':
						$this->proc_project_filters_set();
						break;
					case 'project_list':
						$this->proc_project_list();
						break;
					case 'project_snapshots_list':
						$this->proc_project_snapshots_list();
						break;
					case 'project_activate':
						$this->proc_project_activate();
						break;
					case 'project_task_list':
						$this->proc_project_task_list();
						break;
					case 'task_stats':
						$this->proc_task_stats();
						break;
					case 'task_activate':
						$this->proc_task_activate();
						break;
					case 'task_params_list':
						$this->proc_task_params_list();
						break;
					case 'task_params_save':
						$this->proc_task_params_save();
						break;

					case 'project_stats':
						$this->proc_project_stats();
						break;
					case 'project_stats_xml':
						$this->proc_project_stats_xml();
						break;
					case 'project_stats_calls':
						$this->proc_project_stats_calls();
						break;
					case 'project_stats_pays':
						$this->proc_project_stats_pays();
						break;
					case 'project_stats_billinfo':
						$this->proc_project_stats_billinfo();
						break;

					case 'project_tasks_load':
						$this->proc_project_tasks_load();
						break;

					case 'project_voices_list':
						$this->proc_project_voices_list();
						break;
					case 'project_voices_edit':
						$this->proc_project_voices_edit();
						break;
					case 'project_synthz_list':
						$this->proc_project_synthz_list();
						break;
					case 'project_synthz_load':
						$this->proc_project_synthz_load();
						break;
					case 'project_synthz_del':
						$this->proc_project_synthz_del();
						break;

					case 'project_params_list':
						$this->proc_project_params_list();
						break;
					case 'project_params_save':
						$this->proc_project_params_save();
						break;

					default:
						$logger->log("process: unknown op request ({$_POST['op']}) -> ignore");
				}
		}
		elseif ($session->logged_in)
			$this->proc_logout();
		else
			header('Location: ' . URL_PROMOLOGIN);
	}

	/**
	 * int_send_json
	 */
	function int_send_array_as_json($arr) {
		global $logger;

		//$logger->log('process:int_send_array_as_json=' . print_r($arr, true));

		//mb_internal_encoding("UTF-8");
		header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
		header("Last-Modified: " . gmdate("D, d M Y H:i:s") . "GMT");
		header("Cache-Control: no-cache, must-revalidate");
		header("Pragma: no-cache");
		//header("Content-type: text/x-json");
		header("Content-Type: application/json; Charset=UTF-8");
		$json = json_encode_safe($arr);
		//$logger->log('process:int_send_array_as_json=' . print_r($json, true));
		echo $json;
	}


	/**
	 * proc_login
	 */
	function proc_login() {
		global $session;

		/*if ($session->logged_in) {
			$this->jsonres['error'] = 'AlreadyAuthorized!';
		} else*/
		{
			$loginresult = $session->login($_POST['login'], $_POST['pwd'], $_POST['remember']);
			if (!$loginresult)
				$this->jsonres['error'] = 'Ошибка авторизации. Пользователь не существует или неверно введены параметры авторизации.';
			else {
				$this->jsonres['ok'] = true;
				$this->jsonres['auth'] = $session->logged_in;
				if (isset($_POST['red']))
					$this->jsonres['red'] = URL_PROMOLOGIN;
			}
		}

		$this->int_send_array_as_json($this->jsonres);
	}

	/**
	 * proc_logout
	 */
	function proc_logout() {
		global $session;

		//$logger->log("proc_logout:post=" . print_r($_POST, true));
		//$logger->log("proc_logout:sess=" . print_r($session->syssession, true));

		/*if (!$session->logged_in) {
			$this->jsonres['error'] = 'AlreadyNotAuthorized!';
		} else*/
		{
			$session->logout();
			$this->jsonres['ok'] = true;
			$this->jsonres['red'] = URL_PROMOLOGOUT;
		}

		$this->int_send_array_as_json($this->jsonres);
	}

	/**
	 * proc_check_status
	 */
	function proc_check_status() {
		global $session;

		$this->jsonres['ok'] = true;
		$this->jsonres['whoami'] = "Вы вошли как <span class='bld'>{$session->accountinfo['login']}</span> ({$session->accountinfo['fio']}, группа {$session->accountinfo['rolename']})";
		//$this->jsonres['params'] = array('tfilter_days' => $session->tfilter_days);

		$this->int_send_array_as_json($this->jsonres);
	}

	/**
	 * proc_project_filters_set
	 */
	function proc_project_filters_set($is_internal_call = false) {
		global $session;

		$dt = strnatcmp(phpversion(), '5.3.0') >= 0 ?
			date_parse_from_format('d.m.Y', $_POST['sf_startdate_proj']) : date_parse($_POST['sf_startdate_proj']);
		if ($dt['error_count'] == 0)
			$session->sf_startdate_proj = sprintf("%02d.%02d.%04d", $dt['day'], $dt['month'], $dt['year']);

		$dt = strnatcmp(phpversion(), '5.3.0') >= 0 ?
			date_parse_from_format('d.m.Y', $_POST['sf_enddate_proj']) : date_parse($_POST['sf_enddate_proj']);
		if ($dt['error_count'] == 0)
			$session->sf_enddate_proj = sprintf("%02d.%02d.%04d", $dt['day'], $dt['month'], $dt['year']);

		if ($is_internal_call)
			return true;

		$this->jsonres['ok'] = true;

		$this->int_send_array_as_json($this->jsonres);
		return true;
	}

	/**
	 * proc_project_list
	 *
	 * @return bool
	 */
	function proc_project_list() {
		global $session, $database;

		if (!function_exists('int_get_projectprogress_template')) {
			function int_get_projectprogress_template($id, $done, $total) {
				//http://blog.benogle.com/2009/06/16/simple-css-shiny-progress-bar-technique/
				$percents = 100 * $done / $total;
				$res = "<div id='pmeter_$id' class='meter-wrap'>"
					   . "<div class='meter-value' style='background-color:#0a0;width:$percents%;'>"
					   . "<div class='meter-text'>$done &#47; $total</div>"
					   . "</div></div>";
				return $res;
			}
		}

		$session->initStatFilters();

		$page = $_POST['page'];
		if (!$page)
			$page = 1;

		//this result is totally out of scheme!
		$this->jsonres['page'] = $page;
		$this->jsonres['rows'] = array();

		$totalcnt = 0;
		$pinfos = $database->get_project_list_personal($session->accountinfo['role'],
													   $page, $_POST['rp'], $_POST['sortname'], $_POST['sortorder'], $_POST['qtype'], $_POST['query'],
													   $totalcnt);
		if ($pinfos === null)
			$this->jsonres['total'] = 0;
		else {
			$this->jsonres['total'] = $totalcnt;
			foreach ($pinfos as $pinfo) {
				$ptaskinfo = $database->get_project_tasks_info($pinfo['tm_project_id'], 'null');
				$compl_percent = 0;
				if ($ptaskinfo['tm_tasks_count'] > 0)
					$compl_percent = intval(($ptaskinfo['tm_tasks_count_complited'] / $ptaskinfo['tm_tasks_count']) * 100);
				$this->jsonres['rows'][] = array(
					'id' => '_prj_' . $pinfo['tm_project_id'],
					'cell' => array(
						is_numeric($pinfo['tm_project_task_event']) ?
							'<img src="images/icon_active.png" width="14" height="14" alt="Проект активен" title="Проект активен">' :
							'<img src="images/icon_inactive.png" width="14" height="14" alt="Проект неактивен" title="Проект неактивен">',

						addslashes($pinfo['tm_project_name']),
						$pinfo['tm_project_start_time'],
						$pinfo['tm_project_stop_time'],
						$ptaskinfo['tm_tasks_count_active'] . ' из ' . ($ptaskinfo['tm_tasks_count_active'] + $ptaskinfo['tm_tasks_count_dial_pause']),

						/*int_get_projectprogress_template($pinfo['tm_project_id'],
														 $ptaskinfo['tm_tasks_count_complited'],
														 $ptaskinfo['tm_tasks_count'])*/
						$ptaskinfo['tm_tasks_count_complited'] . ' из ' . $ptaskinfo['tm_tasks_count'] . " ($compl_percent%)"
					)
				);
			}
		}

		$this->int_send_array_as_json($this->jsonres);
		return true;
	}

	/**
	 * proc_project_snapshots_list
	 */
	function proc_project_snapshots_list() {
		global $session, $database;

		$this->jsonres['pid'] = $_POST['pid'];

		if (!is_numeric($_POST['pid'])) {
			$this->jsonres['error'] = 'Проект не задан!';
		} else {
			$snaps = $database->get_project_snapshot_list($_POST['pid']);
			$this->jsonres['ok'] = true;
			$this->jsonres['snapshots'] = $snaps;
			$this->jsonres['snapshotsa'] = isset($session->project_activesnapshot[$_POST['pid']]) ?
				$session->project_activesnapshot[$_POST['pid']] : (count($snaps) > 1 ? $snaps[count($snaps) - 2]['id'] : '0');
		}

		$this->int_send_array_as_json($this->jsonres);
	}

	/**
	 * proc_project_activate
	 */
	function proc_project_activate() {
		global $session, $database;

		$this->jsonres['pids'] = $_POST['pids'];

		if (!is_numeric($_POST['pids'])) {
			$this->jsonres['error'] = 'Проект не задан!';
		} elseif ($database->get_project_userrights($_POST['pids'], $session->accountinfo['role']) != ADMIN_LEVEL) {
			$this->jsonres['error'] = 'У вас недостаточно прав для управления этим проектом.';
		} else {
			$dbres = $database->project_activate($session->accountinfo['role'], $_POST['pids'], $_POST['opt'] == 1);
			if ($dbres === false)
				$this->jsonres['error'] = 'Ошибка изменения состояния проекта!';
			else {
				$this->jsonres['ok'] = true;
				$this->jsonres['project_status'] = $_POST['opt'] == 1;
			}
		}

		$this->int_send_array_as_json($this->jsonres);
	}

	/**
	 * proc_project_task_list
	 *
	 * @return bool
	 */
	function proc_project_task_list() {
		global $session, $database;

		$page = $_POST['page'];
		if (!$page)
			$page = 1;

		//this result is totally out of scheme!
		$this->jsonres['page'] = $page;
		$this->jsonres['rows'] = array();

		if (!isset($_POST['pid']) || !is_numeric($_POST['pid']) || $_POST['pid'] < 0) {
			$this->jsonres['total'] = 0;
			$this->int_send_array_as_json($this->jsonres);
			return false;
		}

		$session->initStatFilters();
		/*if (isset($_POST['tfilter_days']) && is_numeric($_POST['tfilter_days']))
			$session->tfilter_days = intval($_POST['tfilter_days']);*/
		if (isset($_POST['projsnapshot'])) {
			$snaps = $session->project_activesnapshot;
			$snaps[$_POST['pid']] = $_POST['projsnapshot'];
			$session->project_activesnapshot = $snaps;
		}

		/*if ($session->tfilter_days > 0) {
			$starttm = date("d.m.Y", mktime(0, 0, 0, date("m"), date("d") - $session->tfilter_days, date("Y"))) . ' 00:00:00';
			$endtm = date("d.m.Y") . ' 23:59:59';
		} else {
			$starttm = $_POST['starttm'];
			$endtm = $_POST['stoptm'];
		}*/

		/*$flagsin = null;
		$snap = $database->get_project_snapshot_params($_POST['pid'], $session->project_activesnapshot[$_POST['pid']]);
		if (!empty($snap)) {
			$starttm = $snap['tm_project_activate'];
			if (!empty($snap['tm_project_deactivate'])) {
				$endtm = $snap['tm_project_deactivate'];
				$flagsin = 1;
			} else {
				$endtm = date("d.m.Y") . ' 23:59:59';  //null show future tasks?
			}
		} else {
			//ToDo: WTF?
			//$starttm = $_POST['starttm'];
			//$endtm = $_POST['stoptm'];
			$starttm = date("d.m.Y", mktime(0, 0, 0, date("m"), date("d"), date("Y") + 1)) . ' 00:00:00';
			$endtm = date("d.m.Y", mktime(0, 0, 0, date("m"), date("d"), date("Y") + 2)) . ' 23:59:59';
		}*/
		//$starttm = $_POST['starttm'];
		//$endtm = $_POST['stoptm'];

		$totalcnt = 0;
		$project_snapshot = $database->get_project_snapshot_params($_POST['pid'], $session->project_activesnapshot[$_POST['pid']]);
		$tasks = $database->get_project_task_list($_POST['pid'], $project_snapshot['starttm'], $project_snapshot['endtm'], $project_snapshot['is_complete'] ? 1 : null,
												$page, $_POST['rp'], $_POST['sortname'], $_POST['sortorder'], $_POST['qtype'], $_POST['query'],
												$totalcnt);
		if ($tasks === null)
			$this->jsonres['total'] = 0;
		else {
			$this->jsonres['total'] = $totalcnt;
			foreach ($tasks as $task) {
				$statustext = addslashes(task_status_str($task['tm_task_status']));
				$statusicon = 'unknown';
				switch ($task['tm_task_status']) {
					case TMS_STATUS_READY_FOR_DIAL:
					case TMS_STATUS_WAIT_FOR_DIAL:
					case TMS_STATUS_DIALING:
					case TMS_STATUS_DIAL_PAUSE:
					case TMS_STATUS_TECH_BLOCK:
						$statusicon = 'clock';
						break;
					case TMS_STATUS_COMPLETE:
						$statusicon = 'checkgreen';
						break;
					case TMS_STATUS_STOP_DIAL_LIMIT:
						$statusicon = 'checkred';
						break;
					case TMS_STATUS_STOP_BLOCKING:
						$statusicon = 'checkblue';
						break;
				}

				$this->jsonres['rows'][] = array(
					'id' => '_tsk_' . $task['tm_task_id'],
					'cell' => array(
						"<img src='images/icon_{$statusicon}14.png' width='14' height='14' alt='$statustext' title='$statustext'>",
						addslashes($task['tm_task_dial_num']),
						addslashes(task_status_str($task['tm_task_status'])),
						addslashes(dial_status_str($task['tm_task_dial_cause'])),
						addslashes(result_status_str($task['tm_task_result'])),
						$task['tm_task_try_count']
					)
				);
			}
		}

		$this->int_send_array_as_json($this->jsonres);
		return true;
	}

	/**
	 * proc_task_stats
	 *
	 * @return bool
	 */
	function proc_task_stats() {
		global $session, $database;

		$session->initStatFilters();

		$page = $_POST['page'];
		if (!$page)
			$page = 1;

		//this result is totally out of scheme!
		$this->jsonres['page'] = $page;
		$this->jsonres['rows'] = array();

		if (!isset($_POST['tid']) || !is_numeric($_POST['tid']) || $_POST['tid'] < 0) {
			$this->jsonres['total'] = 0;
			$this->int_send_array_as_json($this->jsonres);
			return false;
		}

		$totalcnt = 0;
		$taskstat = $database->get_task_stats($_POST['tid'],
											  $page, $_POST['rp'], $_POST['sortname'], $_POST['sortorder'], $_POST['qtype'], $_POST['query'],
											  $totalcnt);
		if ($taskstat === null)
			$this->jsonres['total'] = 0;
		else {
			$this->jsonres['total'] = $totalcnt;
			foreach ($taskstat as $statrec) {
				$this->jsonres['rows'][] = array(
					'id' => '_tst_' . $_POST['tid'],
					'cell' => array(
						'&nbsp;',
						addslashes($statrec['tm_task_start_time']),
						addslashes(task_status_str($statrec['tm_task_status'])),
						addslashes(dial_status_str($statrec['tm_task_dial_status']))
					)
				);
			}
		}

		$this->int_send_array_as_json($this->jsonres);
		return true;
	}

	/**
	 * proc_project_stats
	 *
	 * @return bool
	 */
	function proc_project_stats() {
		global $session, $database;

		//$session->initStatFilters();
		//$this->proc_project_filters_set(true);

		$page = $_POST['page'];
		if (!$page)
			$page = 1;

		//this result is totally out of scheme!
		$this->jsonres['page'] = $page;
		$this->jsonres['rows'] = array();

		if (!isset($_POST['pid']) || !is_numeric($_POST['pid']) || $_POST['pid'] < 0) {
			$this->jsonres['total'] = 0;
			$this->int_send_array_as_json($this->jsonres);
			return false;
		}

		$totalcnt = 0;
		$project_snapshot = $database->get_project_snapshot_params($_POST['pid'], $_POST['sf_projsnapshot']);
		$tasks = $database->get_project_task_list($_POST['pid'], $project_snapshot['starttm'], $project_snapshot['endtm'], $project_snapshot['is_complete'] ? 1 : null,
			$page, $_POST['rp'], $_POST['sortname'], $_POST['sortorder'], $_POST['qtype'], $_POST['query'],
			$totalcnt);
		if ($tasks === null)
			$this->jsonres['total'] = 0;
		else {
			$this->jsonres['total'] = $totalcnt;
			foreach ($tasks as $task) {
				$statustext = addslashes(task_status_str($task['tm_task_status']));
				$statusicon = 'unknown';
				switch ($task['tm_task_status']) {
					case TMS_STATUS_READY_FOR_DIAL:
					case TMS_STATUS_WAIT_FOR_DIAL:
					case TMS_STATUS_DIALING:
					case TMS_STATUS_DIAL_PAUSE:
					case TMS_STATUS_TECH_BLOCK:
						$statusicon = 'clock';
						break;
					case TMS_STATUS_COMPLETE:
						$statusicon = 'checkgreen';
						break;
					case TMS_STATUS_STOP_DIAL_LIMIT:
						$statusicon = 'checkred';
						break;
					case TMS_STATUS_STOP_BLOCKING:
						$statusicon = 'checkblue';
						break;
				}

				$this->jsonres['rows'][] = array(
					'id' => '_tsk_' . $task['tm_task_id'],
					'cell' => array(
						"<img src='images/icon_{$statusicon}14.png' width='14' height='14' alt='$statustext' title='$statustext'>",
						addslashes($task['tm_task_dial_num']),
						addslashes(task_status_str($task['tm_task_status'])),
						addslashes(dial_status_str($task['tm_task_dial_cause'])),
						addslashes(result_status_str($task['tm_task_result'])),
						addslashes(($task['tm_task_result'] == TMR_STATUS_CONFIRM) ? 'Да' : 'Нет'),
						$task['tm_task_try_count'],
						$task['tm_task_last_time'],
						intval($task['tm_task_wait_answer_time']) + intval($task['tm_task_talk_time'])
					)
				);
			}
		}

		$this->int_send_array_as_json($this->jsonres);
		return true;
	}

	/**
	 * proc_project_stats_xml
	 */
	function proc_project_stats_xml() {
		//create and prepare Report from DB
		global $session, $database, $logger;

		//$session->initStatFilters();
		//$this->proc_project_filters_set(true);

		//this result is totally out of scheme!
		$this->jsonres = array('page' => 1);
		$this->jsonres['rows'] = array();

		$totalcnt = 0;
		$project_snapshot = $database->get_project_snapshot_params($_POST['pid'], urldecode($_POST['sf_projsnapshot']));
		$tasks = $database->get_project_task_list($_POST['pid'], $project_snapshot['starttm'], $project_snapshot['endtm'], $project_snapshot['is_complete'] ? 1 : null,
			1, 1000000, $_POST['sortname'], $_POST['sortorder'], null, null,
			$totalcnt);

		//create XLS
		require_once('Spreadsheet/Excel/Writer.php');

		$project_name = $database->get_project_params($_POST['pid']);
		$project_name = $project_name['tm_project_name'];
		$logger->log("Stats request in Excel for '$project_name' project");
		$excel = new Spreadsheet_Excel_Writer();
		//$excel->setVersion(8);
		$excel->send("Статистика работы проекта '$project_name' с " . substr($project_snapshot['starttm'], 0, 10) . " по " . substr($project_snapshot['endtm'], 0, 10) . ".xls");

		$sheet =& $excel->addWorksheet(substr(iconv('utf-8', 'cp1251', "Проект <$project_name>"), 0, 31));
		if (PEAR::isError($sheet)) {
			$logger->log("excel->addWorksheet ERROR:\n" . print_r($sheet, true));
			$excel->close();
			return false;
		}

		//$sheet->setInputEncoding('utf-8');

		$sheet->setColumn(0, 0, 20.0);
		$sheet->setColumn(1, 1, 18.0);
		$sheet->setColumn(2, 2, 14.0);
		$sheet->setColumn(3, 4, 32.0);
		$sheet->setColumn(5, 5, 16.0);
		$sheet->setColumn(6, 6, 32.0);
		$sheet->setColumn(7, 7, 13.0);
		$sheet->setColumn(8, 8, 38.0);
		$sheet->setColumn(9, 9, 16.0);
		$sheet->setColumn(10, 10, 16.0);
		$sheet->setColumn(11, 11, 11.0);

		//create data formats
		$fmt =& $excel->addFormat(array('NumFormat' => '@'));
		$fmtR =& $excel->addFormat(array('Align' => 'right', 'NumFormat' => '@'));
		$fmtDateTimeR =& $excel->addFormat(array('Align' => 'right', 'NumFormat' => 'DD.MM.YYYY hh:mm:ss'));
		$fmtBold =& $excel->addFormat(array('Bold' => 1, 'NumFormat' => '@'));
		$fmtBoldR =& $excel->addFormat(array('Bold' => 1, 'Align' => 'right', 'NumFormat' => '@'));

		//head
		$rowCount = 0;
		$sheet->writeString($rowCount, 0, iconv('utf-8', 'cp1251', "Статистика работы проекта '$project_name' с " . substr($project_snapshot['starttm'], 0, 10) . " по " . substr($project_snapshot['endtm'], 0, 10)), $fmtBold);
		$rowCount++;

		//column header
		$rowCount++;
		//$sheet->write($rowCount, 0, 'ID', $fmtBoldR);
		$sheet->write($rowCount, 0, iconv('utf-8', 'cp1251', 'Идентификатор'), $fmtBold);
		$sheet->write($rowCount, 1, iconv('utf-8', 'cp1251', 'Дата/время'), $fmtBoldR);
		$sheet->write($rowCount, 2, iconv('utf-8', 'cp1251', 'Номер'), $fmtBoldR);
		$sheet->write($rowCount, 3, iconv('utf-8', 'cp1251', 'Статус'), $fmtBoldR);
		$sheet->write($rowCount, 4, iconv('utf-8', 'cp1251', 'Статус дозвона'), $fmtBoldR);
		$sheet->write($rowCount, 5, iconv('utf-8', 'cp1251', 'Число попыток'), $fmtBoldR);
		$sheet->write($rowCount, 6, iconv('utf-8', 'cp1251', 'Результат'), $fmtBoldR);
		$sheet->write($rowCount, 7, iconv('utf-8', 'cp1251', 'Дозвон, сек.'), $fmtBoldR);
		$sheet->write($rowCount, 8, iconv('utf-8', 'cp1251', 'Продолжительность оповещения, сек.'), $fmtBoldR);
		$sheet->write($rowCount, 9, iconv('utf-8', 'cp1251', 'Опл. время, сек.'), $fmtBoldR);
		$sheet->write($rowCount, 10, iconv('utf-8', 'cp1251', 'Тариф за объём'), $fmtBoldR);
		$sheet->write($rowCount, 11, iconv('utf-8', 'cp1251', 'Стоимость'), $fmtBoldR);

		//data
		$rowCount++;
		foreach ($tasks as $task) {
			//$sheet->writeString($rowCount, 0, $task['tm_task_id'], $fmt);
			$sheet->writeString($rowCount, 0, iconv('utf-8', 'cp1251', $task['tm_task_ext_id']), $fmt);
			$sheet->writeString($rowCount, 1, $task['tm_task_last_time'], $fmtDateTimeR);
			$sheet->writeString($rowCount, 2, $task['tm_task_dial_num'], $fmtR);
			$sheet->writeString($rowCount, 3, iconv('utf-8', 'cp1251', task_status_str($task['tm_task_status'])), $fmtR);
			$sheet->writeString($rowCount, 4, iconv('utf-8', 'cp1251', dial_status_str($task['tm_task_dial_cause'])), $fmtR);
			$sheet->writeString($rowCount, 5, $task['tm_task_try_count'], $fmtR);
			$sheet->writeString($rowCount, 6, iconv('utf-8', 'cp1251', result_status_str($task['tm_task_result'])), $fmtR);
			$sheet->writeString($rowCount, 7, $task['tm_task_wait_answer_time'], $fmtR);
			$sheet->writeString($rowCount, 8, $task['tm_task_talk_time'], $fmtR);
			$sheet->writeString($rowCount, 9, $task['tm_task_pay_time'], $fmtR);
			$sheet->writeString($rowCount, 10, empty($task['tm_task_taiff']) ? '' : format_money($task['tm_task_taiff']), $fmtR);
			$sheet->writeString($rowCount, 11, empty($task['tm_task_pay']) ? '' : format_money($task['tm_task_pay']), $fmtR);
			$rowCount++;
		}

		//footer calculate
		$graphdata = array(
			'total_cnt' => array(0, ''),
			'done_cnt' => array(0, ''),
			'done_1' => array(0, 'Обслужено с 1-го раза'),
			'done_2' => array(0, 'Обслужено со 2-го раза'),
			'done_3' => array(0, 'Обслужено с 3-го раза'),
			'done_4' => array(0, 'Обслужено с 4-го раза'),
			'done_5' => array(0, 'Обслужено с 5-го раза'),
			'done_6' => array(0, 'Обслужено с 6-го раза'),
			'done_7' => array(0, 'Обслужено с 7-го раза'),
			'done_8' => array(0, 'Обслужено с 8-го раза'),
			'done_9' => array(0, 'Обслужено с 9-го раза'),
			'done_10' => array(0, 'Обслужено с 10-го раза'),
			'failed_cnt' => array(0, ''),
			'failed_u' => array(0, 'Без ответа на вызов'),
			'failed_i' => array(0, 'Без подтверждения прослушивания')
		);
		$graphdata['total_cnt'][0] = count($tasks);
		foreach ($tasks as $task) {
			switch ($task['tm_task_status']) {
				case TMS_STATUS_DIAL_PAUSE:
				case TMS_STATUS_STOP_DIAL_LIMIT:
				case TMS_STATUS_TECH_BLOCK:
					$graphdata['failed_cnt'][0]++;
					$graphdata['failed_u'][0]++;
					break;
				case TMS_STATUS_STOP_BLOCKING:
				case TMS_STATUS_COMPLETE:
					if ($task['tm_task_result'] == TMR_STATUS_CONFIRM) {
						$graphdata['done_cnt'][0]++;
						$graphdata['done_' . $task['tm_task_try_count']][0]++;
					} else {
						$graphdata['failed_cnt'][0]++;
						$graphdata['failed_i'][0]++;
					}
					break;
				default:
					$graphdata['failed_cnt'][0]++;
					break;
			}
		}

		//footer show
		$rowCount++;
		$sheet->writeString($rowCount, 0, iconv('utf-8', 'cp1251', "Всего задач: {$graphdata['total_cnt'][0]}"), $fmt);
		$rowCount++;
		$recs = 0;
		foreach ($graphdata as $gd) {
			if ($gd[0] > 0 && !empty($gd[1]))
				$recs++;
		}
		if ($recs > 0) {
			$sheet->writeString($rowCount, 0, iconv('utf-8', 'cp1251', 'Из них'), $fmt);
			$rowCount++;
			foreach ($graphdata as $gd) {
				if ($gd[0] > 0 && !empty($gd[1])) {
					$sheet->writeString($rowCount, 0, iconv('utf-8', 'cp1251', "   {$gd[1]}: {$gd[0]}"), $fmt);
					$rowCount++;
				}
			}
		}

		//finita!
		if ($excel->close() !== true) {
			$logger->log('GenerateStatsTableAsXLS: error XLS!');
			return false;
		}
		$rowCount--;
		$logger->log("Write to XLS -> $rowCount record");

		return true;
	}

	/**
	 * proc_project_stats_calls
	 *
	 * @return bool
	 */
	function proc_project_stats_calls() {
		global $session, $database;

		$page = $_POST['page'];
		if (!$page)
			$page = 1;

		//this result is totally out of scheme!
		$this->jsonres['page'] = $page;
		$this->jsonres['rows'] = array();

		if (!isset($_POST['pid']) || !is_numeric($_POST['pid']) || $_POST['pid'] < 0) {
			$this->jsonres['total'] = 0;
			$this->int_send_array_as_json($this->jsonres);
			return false;
		}

		$totalcnt = 0;
		$report = $database->get_project_stats_calls($_POST['pid'], -1/*$_POST['flagsin']*/,
			$page, $_POST['rp'], $_POST['sortname'], $_POST['sortorder'], $_POST['qtype'], $_POST['query'],
			$totalcnt);
		if ($report === null)
			$this->jsonres['total'] = 0;
		else {
			$this->jsonres['total'] = $totalcnt;
			foreach ($report as $row) {
				$volume = format_duration($row['payablevolume']);
				$flagsout = '';
				switch ($row['flagsout']) {
					case DB_SERVICEID_MTR:
						$flagsout = '<img src="images/icon_mtr.gif" width="16" height="14" alt="Телефонный звонок" title="Телефонный звонок">';
						break;
					case DB_SERVICEID_MSG_IN:
						$flagsout = '<img src="images/icon_msg_in.gif" width="16" height="14" alt="Прием сообщения" title="Прием сообщения">';
						$volume = $row['payablevolume'];
						break;
					case DB_SERVICEID_MSG_OUT:
						$flagsout = '<img src="images/icon_msg_out.gif" width="16" height="14" alt="Отправка сообщения" title="Отправка сообщения">';
						$volume = $row['payablevolume'];
						break;
				}
				$this->jsonres['rows'][] = array(
					'id' => $row['sessionid'] . '_' . $session->generateRandStr(16),
					'cell' => array(
						$flagsout,
						$row['creattime'],
						$row['numbera'],
						$row['numberb'],
						format_money($row['pay']),
						$volume,
						isset($row['distancename']) ? addslashes($row['distancename']) : addslashes($row['geographyname'])
					)
				);
			}
		}

		$this->int_send_array_as_json($this->jsonres);
		return true;
	}

	/**
	 * proc_project_stats_pays
	 *
	 * @return bool
	 */
	function proc_project_stats_pays() {
		global $session, $database;

		$page = $_POST['page'];
		if (!$page)
			$page = 1;

		//this result is totally out of scheme!
		$this->jsonres['page'] = $page;
		$this->jsonres['rows'] = array();

		if (!isset($_POST['pid']) || !is_numeric($_POST['pid']) || $_POST['pid'] < 0) {
			$this->jsonres['total'] = 0;
			$this->int_send_array_as_json($this->jsonres);
			return false;
		}

		$totalcnt = 0;
		$dbres = $database->get_project_stats_pays($_POST['pid'],
			$page, $_POST['rp'], $_POST['sortname'], $_POST['sortorder'], $_POST['qtype'], $_POST['query'],
			$totalcnt);
		if (empty($dbres))
			$this->jsonres['total'] = 0;
		else {
			$this->jsonres['total'] = $totalcnt;
			foreach ($dbres as $row) {
				$row['paysrc'] = str_replace('SYSDBA', 'Администратор', $row['paysrc']);
				if (empty($row['payinfo']))
					$row['payinfo'] = ($row['paysumm'] > 0) ? 'Пополнение' : 'Списание';
				else {
					if ($row['paysumm'] != 0)
						$row['payinfo'] = (($row['paysumm'] > 0) ? 'Пополнение: ' : 'Списание: ')
											. iconv('cp1251', 'utf-8', strtolower(iconv('utf-8', 'cp1251', $row['payinfo'])));
				}
				$this->jsonres['rows'][] = array(
					'id' => $session->generateRandStr(32),
					'cell' => array(
						empty($row['paydate']) ? '' : $row['paydate'],
						(($row['paysumm'] > 0) ? '+' : (($row['paysumm'] < 0) ? '' : '-')) . format_money($row['paysumm']),
						addslashes($row['payinfo']),
						addslashes($row['paysrc'])
					)
				);
			}
		}

		$this->int_send_array_as_json($this->jsonres);
		return true;
	}

	/**
	 * proc_project_stats_billinfo
	 */
	function proc_project_stats_billinfo() {
		global $database, $database_dynmenu;

		if (!isset($_POST['pid']) || !is_numeric($_POST['pid']) || $_POST['pid'] < 0) {
			$this->jsonres['error'] = 'Не задан проект.';
		} else {
			$res = $database->get_project_billing_account($_POST['pid']);
			if ($res == false)
				$this->jsonres['error'] = 'Информация недоступна. Тип авторизации проекта не предполагает привязку к биллингу.';
			elseif ($res == -1)
				$this->jsonres['error'] = 'Информация недоступна. В параметрах проекта указаны неверные параметры авторизации.';
			else {
				$this->jsonres['ok'] = true;
				unset($res['emitterkcid']);
				unset($res['accountid']);
				unset($res['pin']);
				unset($res['number']);
				$this->jsonres['params'] = $res;
			}
		}

		$this->int_send_array_as_json($this->jsonres);
	}

	/**
	 * proc_project_tasks_load
	 */
	function proc_project_tasks_load() {
		global $session, $database, $logger;

		$proj_id = $_POST['pid'];
		if ($database->get_project_userrights($proj_id, $session->accountinfo['role']) != ADMIN_LEVEL) {
			$this->jsonres['error'] = 'У вас недостаточно прав для создания задач в этом проекте.';
		} elseif (!empty($_FILES)) {
			$logger->log("Adding tasks to project id $proj_id", PEAR_LOG_DEBUG);

			$tempfile = $_FILES['Filedata']['tmp_name'];
			$targetpath = $_SERVER['DOCUMENT_ROOT'] . $_REQUEST['folder'] . '/';
			$targetfile = str_replace('//', '/', $targetpath) . $_FILES['Filedata']['name'];
			$logger->log("Will move uploaded file from '$tempfile' to '$targetfile'", PEAR_LOG_DEBUG);
			mkdir(str_replace('//', '/', $targetpath), 0755, true);
			if (!move_uploaded_file($tempfile, $targetfile)) {
				$this->jsonres['error'] = 'Ошибка сохранения загруженного файла.';
				$logger->log("ERROR: move_uploaded_file($tempfile, $targetfile) failed", PEAR_LOG_ERR);
			} else {
				$handle = fopen($targetfile, "r");
				if ($handle === false) {
					$this->jsonres['error'] = 'Ошибка чтения загруженного файла.';
					$logger->log("ERROR: fopen($targetfile) failed", PEAR_LOG_ERR);
				} else {
					//Get records from csv-file
					$row = 0;
					$t_succ = 0;
					$t_ins = 0;
					$t_udt = 0;
					$t_wpj = 0;
					$t_wtext = 0;
					while (($data = fgetcsv($handle, 1000, ";")) !== false) {
						//$logger->log("csv data: " . var_export($data, true), PEAR_LOG_DEBUG);
						if (count($data) < 8)
							continue;
						if (substr($data[0], 0, 3) == pack('CCC', 0xEF, 0xBB, 0xBF)) { //strip BOM if any
							$data[0] = substr($data[0], 3);
							$logger->log("Removed BOM from uploaded file", PEAR_LOG_DEBUG);
						}
						$database->update_project_task($proj_id, $data, $flagsout);
						if (isset($flagsout)) {
							if ($flagsout >= 0) {
								if ($flagsout == 0) $t_ins++;
								if ($flagsout == 1) $t_udt++;
								$t_succ++;
							} else {
								if ($flagsout == -1) $t_wpj++;
								if ($flagsout == -2) $t_wtext++;
							}
						}
						$row++;
						/*
						$num = count($data);
						echo "<p> $num полей в строке $row: <br /></p>\n";
						$row++;
						for ($c=0; $c < $num; $c++) {
							echo $data[$c] . "<br />\n";
						}
						*/
					}
					$logger->log("Added $row tasks to project id $proj_id [successes=$t_succ, errors=" . ($row - $t_succ) . "]", PEAR_LOG_DEBUG);
					fclose($handle);

					//echo str_replace($_SERVER['DOCUMENT_ROOT'],'',$targetFile);
					//$row - row produced
					//($row-$t_succ) - error
					//$t_ins   - inserted
					//$t_udt   - updated
					//$t_wpj   - wrong project
					//$t_wtext = wrong task external identifier
					//echo "Process=$row[success=$t_succ,error=<noproj=$t_wpj,wrong_ext=$t_wtext>,update=$$t_udt,insert=$t_ins]";
					$this->jsonres['result'][] = array(
						'rows' => $row,
						'success' => $t_succ,
						'inserted' => $t_ins,
						'updated' => $t_udt,
						'wr_project' => $t_wpj,
						'wr_ext_id' => $t_wtext
					);
				}
			}
		} else {
			$this->jsonres['error'] = 'Файловый дескриптор пуст.';
			$logger->log('ERROR: File upload description is empty', PEAR_LOG_ERR);
		}

		$this->int_send_array_as_json($this->jsonres);
	}

	/**
	 * proc_project_synthz_list
	 */
	function proc_project_synthz_list() {
		global $session, $database, $database_dynmenu;

		$page = $_POST['page'];
		if (!$page)
			$page = 1;

		//this result is totally out of scheme!
		$this->jsonres['page'] = $page;
		$this->jsonres['rows'] = array();

		$menuid = $database->get_project_params($_POST['pid']);
		$menuid = $menuid['tm_project_menuid'];

		if (!isset($_POST['pid']) || !is_numeric($_POST['pid']) || $_POST['pid'] < 0 ||
			$menuid == -1 || $menuid == '') {
			$this->jsonres['total'] = 0;
			$this->int_send_array_as_json($this->jsonres);
			return false;
		}

		$totalcnt = 0;
		$synthz = $database_dynmenu->getSynthsList($menuid,
			$page, $_POST['rp'], $_POST['sortname'], $_POST['sortorder'], $_POST['qtype'], $_POST['query'],
			$totalcnt);
		if (empty($synthz))
			$this->jsonres['total'] = 0;
		else {
			$this->jsonres['total'] = $totalcnt;
			foreach ($synthz as $syn) {
				$this->jsonres['rows'][] = array(
					'id' => $syn['id'],
					'cell' => array(
						$syn['id'],
						($syn['place'] == 1) ? 'Нет' : 'Да',
						addslashes($syn['description'])
					)
				);
			}
		}

		$this->int_send_array_as_json($this->jsonres);
		return true;
	}

	/**
	 * proc_project_voices_list
	 */
	function proc_project_voices_list() {
		global $session, $database, $database_dynmenu;

		$page = $_POST['page'];
		if (!$page)
			$page = 1;

		//this result is totally out of scheme!
		$this->jsonres['page'] = $page;
		$this->jsonres['rows'] = array();

		$menuid = $database->get_project_params($_POST['pid']);
		$menuid = $menuid['tm_project_menuid'];

		if (!isset($_POST['pid']) || !is_numeric($_POST['pid']) || $_POST['pid'] < 0 ||
			$menuid == -1 || $menuid == '') {
			$this->jsonres['total'] = 0;
			$this->int_send_array_as_json($this->jsonres);
			return false;
		}

		$totalcnt = 0;
		$synthz = $database_dynmenu->getUserEditableSynths($menuid);
		if (empty($synthz))
			$this->jsonres['total'] = 0;
		else {
			$this->jsonres['total'] = count($synthz);
			foreach ($synthz as $voice) {
				$this->jsonres['rows'][] = array(
					'id' => $voice['item_id'],
					'cell' => array(
						addslashes($voice['item_name']),
						$voice['item_voice']
					)
				);
			}
		}

		$this->int_send_array_as_json($this->jsonres);
		return true;
	}

	/**
	 * proc_project_voices_edit
	 */
	function proc_project_voices_edit() {
		global $session, $database, $database_dynmenu;

		if (!isset($_POST['pid']) || !is_numeric($_POST['pid']) || $_POST['pid'] < 0) {
			$this->jsonres['error'] = 'Не задан проект.';
		} elseif ($database->get_project_userrights($_POST['pid'], $session->accountinfo['role']) != ADMIN_LEVEL) {
			$this->jsonres['error'] = 'У вас недостаточно прав для изменения параметров этого проекта.';
		} else {
			$res = $database_dynmenu->setItemSynths($_POST['vid'], $_POST['synids']);
			if (!$res)
				$this->jsonres['error'] = 'Системная ошибка при сохранении изменений.';
			else
				$this->jsonres['ok'] = true;
		}

		$this->int_send_array_as_json($this->jsonres);
	}

	/**
	 * proc_project_synthz_load
	 */
	function proc_project_synthz_load() {
		global $database, $database_dynmenu, $fileserver_control, $logger;

		$this->jsonres['upload_result'] = array(
			'status' => 'error',
			'error' => 'Внутренняя ошибка'
		);
		$upresult = &$this->jsonres['upload_result'];
		if (!empty($_FILES) && !empty($_FILES['Filedata']) && !empty($_FILES['Filedata']['name']))
			$upresult['name'] = $_FILES['Filedata']['name'];

		$projid = isset($_POST['pid']) ? $_POST['pid'] : -1;
		$menuid = $database->get_project_params($projid);
		$menuid = $menuid['tm_project_menuid'];
		$logger->log("Adding synthz to project id $projid (menu id $menuid):" . print_r($_FILES, true), PEAR_LOG_DEBUG);

		if ($projid == -1) {
			$upresult['error'] = 'Не задан проект для загрузки.';
		} elseif ($menuid == -1 || $menuid == '') {
			$upresult['error'] = 'У проекта отсутствует привязка к IVR-схеме.';
		} elseif (empty($_FILES) && empty($_FILES['Filedata'])) {
			$upresult['error'] = 'Файл для загрузки не задан.';
		} elseif ($_FILES['Filedata']['error'] !== UPLOAD_ERR_OK) {
			$upresult['error'] = isset($uploadErrors[$_FILES['Filedata']['error']]) ?
					$uploadErrors[$_FILES['Filedata']['error']] : 'Неизвестная ошибка при загрузке файла';
		} elseif (($_FILES['Filedata']['name'] == '') || ($_FILES['Filedata']['size'] <= 0)) {
			$upresult['error'] = 'Файл для загрузки не задан или имеет нулевой размер.';
		} elseif (($file = System::mktemp('aup_')) && move_uploaded_file($_FILES['Filedata']['tmp_name'], $file)) {
			//sleep(5);
			$fileid = null;
			$file = prepareVoiceFileForFileServer($file, preg_match('/audio\/mpeg/i', $_FILES['Filedata']['type']) ||
														 preg_match('/.mp3/i', $_FILES['Filedata']['name']));
			$res = $fileserver_control->PlaceFile($file, $fileid, false, true);
			if ($res == FS_ERROR_OK) {
				$database_dynmenu->addSynth($fileid, 1, $menuid, $_FILES['Filedata']['name']);
				$upresult['status'] = 'ok';
				unset($upresult['error']);
				$upresult['fileid'] = $fileid;
			} else {
				switch ($fileserver_control->ErrorDesc) {
					case 'error 133':
						$upresult['error'] = 'Неизвестный формат файла';
						break;
					case 'error 134':
						$upresult['error'] = 'Ошибка конвертации файла во внутренний формат';
						break;
					default:
						$upresult['error'] = 'Внутренняя ошибка FS: ' . $fileserver_control->ErrorDescription($res);
						break;
				}
			}
		}

		$this->int_send_array_as_json($this->jsonres);
	}


	/**
	 * proc_project_synthz_del
	 */
	function proc_project_synthz_del() {
		global $database, $database_dynmenu;

		$menuid = $database->get_project_params($_POST['pid']);
		$menuid = $menuid['tm_project_menuid'];
		if (!isset($_POST['pid']) || !is_numeric($_POST['pid']) || $_POST['pid'] < 0 ||
			$menuid == -1 || $menuid == '') {
			$this->jsonres['error'] = 'Не задан проект или отсутствует привязка к IVR-схеме.';
		} else {
			$res = $database_dynmenu->deleteSynth($_POST['synthids'], 1, $menuid);
			if ($res < 0)
				$this->jsonres['error'] = 'Системная ошибка удаления файла.';
			else
				$this->jsonres['ok'] = true;
		}

		$this->int_send_array_as_json($this->jsonres);
	}

	/**
	 * proc_task_activate
	 */
	function proc_task_activate() {
		global $session, $database;

		$this->jsonres['tids'] = $_POST['tids'];

		if (!is_numeric($_POST['tids'])) {
			$this->jsonres['error'] = 'Задача не задана!';
		} elseif ($database->get_task_userrights($_POST['tids'], $session->accountinfo['role']) != ADMIN_LEVEL) {
			$this->jsonres['error'] = 'У вас недостаточно прав для управления задачами этого проекта.';
		} else {
			$dbres = $database->task_activate($session->accountinfo['role'], $_POST['tids'], $_POST['opt'] == 1);
			if ($dbres === false)
				$this->jsonres['error'] = 'Ошибка изменения состояния задачи!';
			else {
				$this->jsonres['ok'] = true;
				$this->jsonres['task_status'] = $_POST['opt'] == 1;
			}
		}

		$this->int_send_array_as_json($this->jsonres);
	}

	/**
	 * proc_project_params_list
	 */
	function proc_project_params_list() {
		global $database, $database_dynmenu;

		if (!isset($_POST['pid']) || !is_numeric($_POST['pid']) || $_POST['pid'] < 0) {
			$this->jsonres['error'] = 'Не задан проект.';
		} else {
			$res = $database->get_project_params($_POST['pid']);
			if ($res['tm_project_name'] == 'unknown')
				$this->jsonres['error'] = 'Ошибка чтения параметров проекта.';
			else {
				$this->jsonres['ok'] = true;
				$this->jsonres['params'] = $res;

				$this->jsonres['menulist'][] = array('id'=> -1, 'name'=> '< Не выбрана >');
				$menulist = $database_dynmenu->getMenuList();
				foreach ($menulist as $menu)
					$this->jsonres['menulist'][] = array('id'=> $menu['menu_id'], 'name'=> $menu['menu_name']);

				if ($database->get_project_billing_account($_POST['pid']) == -1)
					$this->jsonres['badbilling'] = 'Счет с указанными параметрами авторизации отсутствует в БД Биллинга!';
			}
		}

		$this->int_send_array_as_json($this->jsonres);
	}

	/**
	 * proc_project_params_save
	 */
	function proc_project_params_save() {
		global $database, $session;

		if (!isset($_POST['pid']) || !is_numeric($_POST['pid']) || $_POST['pid'] < 0) {
			$this->jsonres['error'] = 'Не задан проект.';
		} elseif ($database->get_project_userrights($_POST['pid'], $session->accountinfo['role']) != ADMIN_LEVEL) {
			$this->jsonres['error'] = 'У вас недостаточно прав для изменения параметров этого проекта.';
		} else {
			$failcnt = 0;
			$failcnt += ($database->set_project_param($_POST['pid'], 'tm_project_auth_type', $_POST['tm_project_auth_type']) === false) ? 1:0;
			$failcnt += ($database->set_project_param($_POST['pid'], 'tm_project_auth_id', $_POST['tm_project_auth_id'], 'text') === false) ? 1:0;
			$failcnt += ($database->set_project_param($_POST['pid'], 'tm_project_task_max', $_POST['tm_project_task_max']) === false) ? 1:0;
			$failcnt += ($database->set_project_param($_POST['pid'], 'tm_project_dial_count', $_POST['tm_project_dial_count']) === false) ? 1:0;
			$failcnt += ($database->set_project_param($_POST['pid'], 'tm_project_menuid', $_POST['tm_project_menuid']) === false) ? 1:0;
			$this->jsonres['ok'] = true;
			$this->jsonres['failcnt'] = $failcnt;

			if ($database->get_project_billing_account($_POST['pid']) == -1)
				$this->jsonres['badbilling'] = 'Счет с указанными параметрами авторизации отсутствует в БД Биллинга!';
		}

		$this->int_send_array_as_json($this->jsonres);
	}

	/**
	 * proc_task_params_list
	 */
	function proc_task_params_list() {
		global $database;

		if (!isset($_POST['tid']) || !is_numeric($_POST['tid']) || $_POST['tid'] < 0) {
			$this->jsonres['error'] = 'Не задана задача проекта.';
		} else {
			$res = $database->get_task_params($_POST['tid']);
			if (empty($res))
				$this->jsonres['error'] = 'Ошибка чтения параметров задачи.';
			else {
				$this->jsonres['ok'] = true;
				$this->jsonres['params'] = $res;
			}
		}

		$this->int_send_array_as_json($this->jsonres);
	}

	/**
	 * proc_task_params_save
	 */
	function proc_task_params_save() {
		global $database, $session;

		if (!isset($_POST['tid']) || !is_numeric($_POST['tid']) || $_POST['tid'] < 0) {
			$this->jsonres['error'] = 'Не задана задача проекта.';
		} elseif ($database->get_task_userrights($_POST['tid'], $session->accountinfo['role']) != ADMIN_LEVEL) {
			$this->jsonres['error'] = 'У вас недостаточно прав для изменения параметров задач этого проекта.';
		} else {
			$failcnt = 0;
			$failcnt += ($database->set_task_param($_POST['tid'], 'tm_task_try_count', 0) === false) ? 1:0;
			$failcnt += ($database->set_task_param($_POST['tid'], 'tm_task_status', $_POST['tm_task_status']) === false) ? 1:0;
			$failcnt += ($database->set_task_param($_POST['tid'], 'tm_task_dial_num', $_POST['tm_task_dial_num'], 'text') === false) ? 1:0;
			$failcnt += ($database->set_task_param($_POST['tid'], 'tm_task_auth_id', $_POST['tm_task_auth_id'], 'text') === false) ? 1:0;
			$failcnt += ($database->set_task_param($_POST['tid'], 'tm_task_params', $_POST['tm_task_params'], 'text') === false) ? 1:0;
			$this->jsonres['ok'] = true;
			$this->jsonres['failcnt'] = $failcnt;
		}

		$this->int_send_array_as_json($this->jsonres);
	}

}

$process = new Process;

?>
