<?php
/**
 * widget_projectprops.php
 */
require_once(dirname(__FILE__) . '/include/session.php');

global $session, $database;
if (!$session->db_ok) {
	print('database not ok');
	die();
}
?>

<script type="text/javascript">
	var dialogprojectprops_prjid = null;
	var uploader_ready = false;
	var project_synthz_names = new Array();

	function update_project_params() {
		$('#bt_project_save').attr('disabled', 'disabled').addClass('disabled');
		$('#tm_project_params .text').val('').css('background','#fff url("images/loading-dots.gif") no-repeat center center');
		$('#tm_project_menuid').empty();
		$.ajax({
			type: 'POST',
			url: 'process',
			data: ({
				op: 'project_params_list',
				pid: dialogprojectprops_prjid
			}),
			dataType: 'json',
			async: true,
			success: function(data) {
				$('#tm_project_params .text').css('background','#fff');
				if (data.error) {
					alert(data.error);
				} else {
					if (data.menulist) {
						var opts = '';
						$.each(data.menulist, function(i, item) {
							opts += '<option value="' + item.id + '">' + item.name +
									((item.id >= 0) ? ' ('+item.id+')' : '') +
									'</option>';
						});
						$('#tm_project_menuid').html(opts);
					}
					$.each(data.params, function(pname, pvalue){
						$('#dialogprojectprops #' + pname).val(pvalue);
					});
					if (data.badbilling)
						$('#projectparams_badbillingmsg').html(data.badbilling).show();
				}
				$('#bt_project_save').removeAttr('disabled').removeClass('disabled');
			}
		});
	}

	function updateProjectProps(projID) {
		var doreload = (dialogprojectprops_prjid != projID);
		dialogprojectprops_prjid = projID;
		if (doreload) {
			//params
			update_project_params();

			//voices and synthz
			$("#projectprops_synthz").flexReload();
			$("#projectprops_voices").flexReload();
		}
	}

	function playVoice(recordids, recordtitle, playerid) {
		if (!recordtitle)
			recordtitle = '';
		if (!playerid)
			playerid = 'voiceplayer';
		var arrids = new String(recordids);
		if (arrids.indexOf(",") >= 0) {
			arrids = arrids.split(",");
			var res = "";
			for (var i = 0; i < arrids.length; i++) {
				if (res == "")
					res = 'fs_getfile?id='+arrids[i]+'&ttl='+recordtitle;
				else
					res = res + "," + 'fs_getfile?id='+arrids[i]+'&ttl='+recordtitle;
			}
			AudioPlayer.load(playerid, res, '', '');
		} else {
			AudioPlayer.load(playerid, 'fs_getfile?id='+recordids+'&ttl='+recordtitle, '', '');
		}
		AudioPlayer.open(playerid);
		return false;
	}

	function hidePlayer(playerid) {
		if (!playerid)
			playerid = 'voiceplayer';
		AudioPlayer.close(playerid);
		return false;
	}

	function synthz_toolbar_cmd(cmdname, grid, cmdid) {
		switch (cmdid) {
			case 'bt_synthz_stop':
				hidePlayer('voiceplayer');
				return true;
				break;
		}

		var selection = $('.trSelected', grid);
		if (selection.length == 0)
			return false;
		var recs = selection.children('td');
		var info = $(recs[2]).children('div').html();
		var synthid = selection[0].id.substr(3);

		switch (cmdid) {
			case 'bt_synthz_play':
				playVoice(synthid, '', 'voiceplayer');
				break;

			case 'bt_synthz_edit':
				alert('TBD');
				break;

			case 'bt_synthz_del':
				if (confirm(cmdname + ' "' + info + '"?')) {
					$.ajax({
						type: 'POST',
						url: 'process',
						data: ({op: 'project_synthz_del', synthids: synthid, pid: dialogprojectprops_prjid}),
						dataType: 'json',
						success: function(data) {
							if (data.error) {
								alert(data.error);
							} else {
								$("#projectprops_synthz").flexReload();
								$("#projectprops_voices").flexReload();
							}
						}
					});
				}
				break;
		}
		return true;
	}

	function voices_toolbar_cmd(cmdname, grid, cmdid) {
		switch (cmdid) {
			case 'bt_voices_play':
				var selection = $('.trSelected', grid);
				if (selection.length == 0)
					return false;
				var recs = selection.children('td');
				var item_name = $(recs[0]).children('div').html();
				var voicelist = $(recs[1]).children('div').html();
				var item_id = selection[0].id.substr(3);

				playVoice(voicelist, '', 'voiceplayer2');
				break;

			case 'bt_voices_stop':
				hidePlayer('voiceplayer2');
				break;

			case 'bt_voices_refresh':
				$("#projectprops_voices").flexReload();
				break;
		}
		return true;
	}

	function voiceedit_toolbar_cmd(cmdname, grid, cmdid) {
		var voice_row = $("#projectprops_voices").find('tr.trSelected');
		var voice_id = voice_row[0].id.substr(3);
		var voice_synlist = '';
		var rows = $(grid).find('tr');
		$.each(rows, function(i, vc) {
			voice_synlist += (voice_synlist == '' ? '' : ',') + vc.id.substr(3);
		});

		switch (cmdid) {
			case 'bt_voiceedit_add':
				if ($('select#projectprops_voiceselect').val() < 0)
					return false;

				voice_synlist += (voice_synlist == '' ? '' : ',') + $('select#projectprops_voiceselect').val();

				var recs = $(voice_row).children('td');
				$(recs[1]).children('div').html(voice_synlist);

				$(voice_row).removeClass('trSelected').click();
				break;

			case 'bt_voiceedit_commit':
				$.ajax({
					type: 'POST',
					url: 'process',
					data: ({op: 'project_voices_edit', pid: dialogprojectprops_prjid, vid: voice_id, synids: voice_synlist}),
					dataType: 'json',
					success: function(data) {
						if (data.error) {
							alert(data.error);
						} else {
							var recs = $(voice_row).children('td');
							$(recs[1]).children('div').html(voice_synlist);
						}
					}
				});
				break;
		}

		/*var selection = $('.trSelected', grid);
		if (selection.length == 0)
			return false;
		var recs = selection.children('td');
		var item_name = $(recs[0]).children('div').html();
		var voicelist = $(recs[1]).children('div').html();
		var item_id = selection[0].id.substr(3);

		switch (cmdid) {
			case 'bt_voiceedit_del':
				selection.remove();
				break;

			case 'bt_voiceedit_up':
				selection.insertBefore(selection.prev());
				break;

			case 'bt_voiceedit_dn':
				selection.insertAfter(selection.next());
				break;
		}*/
		return true;
	}

	function bind_synthops() {
		$('.sy_play, .sy_del, .sy_up, .sy_dn').addClass('imglink').click(function() {
			var syrow = $(this).parents('tr#row' + $(this).attr('rel'));
			syrow.siblings().removeClass('trSelected');
			syrow.addClass('trSelected');

			var cnames = this.className;
			if (cnames.search(/sy_play/gi) >= 0)
				playVoice($(this).attr('rel'), '', 'voiceplayer2');
			else
			if (cnames.search(/sy_del/gi) >= 0)
				syrow.remove();
			else
			if (cnames.search(/sy_up/gi) >= 0)
				syrow.insertBefore(syrow.prev());
			else
			if (cnames.search(/sy_dn/gi) >= 0)
				syrow.insertAfter(syrow.next());

			return false;
		});

		$("#projectprops_voiceedit tr").hover(
			function() {
				$(this).find('img').css('opacity','1');
			},
			function() {
				$(this).find('img').css('opacity','0.1');
			}
		);
	}

	$(document).ready(function() {
		$('#dialogprojectprops').overlay().load();

		$('#dialogprojectprops .close').click(function() {
			$(this).parent().overlay().close();
			return false;
		});

		$('#dialogprojectprops').bind('onClose', function(event) {
			$('#projectparams_badbillingmsg').html('').hide();
			$("#projectprops_upload #queue_clear").click();
		});

		$("#projectprops_synthz").flexigrid({
			url: 'process',
			params: [{name: 'op', value: 'project_synthz_list'}],
			dataType: 'json',
			colModel: [
				{display: 'Идентификатор', name: 'id', width: 85, sortable: true, align: 'right'},
				{display: 'На плате', name: 'place', width: 48, sortable: true, align: 'right'},
				{display: 'Название', name: 'description', width: 350, sortable: true, align: 'left'}
			],
			buttons: [
				{name: 'Прослушать файл', cmd: 'bt_synthz_play', bclass: 'btplay', onpress: synthz_toolbar_cmd},
				{name: '&nbsp;', cmd: 'bt_synthz_stop', bclass: 'btstop', onpress: synthz_toolbar_cmd},
				/*{separator: true},
				{name: 'Переименовать', cmd: 'bt_synthz_edit', bclass: 'btrename', onpress: synthz_toolbar_cmd},*/
				{separator: true},
				{name: 'Удалить', cmd: 'bt_synthz_del', bclass: 'btdel', onpress: synthz_toolbar_cmd}
			],
			sortname: "id",
			sortorder: "asc",
			title: false,
			showToggleBtn: false,
			singleSelect: true,
			striped: false,
			usepager: true,
			useRp: false,
			rp: 100,
			rpOptions: [10,25,50,100],
			showTableToggleBtn: false,
			width: 540,
			height: 304,
			resizable: false,
			errormsg: 'Список голосовых файлов недоступен. Попробуйте позже.',
			pagestat: 'Отображены файлы с {from} по {to} из {total}',
			pagetext: 'Страница',
			outof: 'из',
			findtext: 'Поиск&nbsp;',
			procmsg: 'Чтение...',
			rphint: 'Количество записей на странице',
			reloadhint: 'Обновить данные',
			nomsg: 'Нет файлов',
			autoload: false,
			/*onError: function(XMLHttpRequest, textStatus, errorThrown) {
				progressnotify_stop();
				return true;
			},
			onSuccess: function() {
				progressnotify_stop();
				return true;
			},*/
			preProcess: function(data) {
				var options = '';
				project_synthz_names = new Array();
				$.each(data.rows, function(i, syn) {
					options += '<option value="' + syn.cell[0] + '">' + syn.cell[2] + '</option>';
					project_synthz_names[syn.cell[0]] = syn.cell[2];
				});
				$('select#projectprops_voiceselect').html(options);
				return data;
			},
			onSubmit: function() {
				//progressnotify_start();
				$("#projectprops_synthz").flexOptions({
					params: [
						{name: 'op', value: 'project_synthz_list'},
						{name: 'pid', value: dialogprojectprops_prjid}
					]
				});
				return true;
			}/*,
			onSuccess: function() {
				$("#projectprops_synthz>tbody").find('tr').hover(function() {
					$(this).children('td:first').children('div:first')  $('#listbuttons')

				}, function () {
					$(this).css('color','green');
				});
			}*/,
			onDblClick: function(row) {
				playVoice(row.id.substr(3), '', 'voiceplayer');
			}
		});

		$("#projectprops_voices").flexigrid({
			url: 'process',
			params: [{name: 'op', value: 'project_voices_list'}],
			dataType: 'json',
			colModel: [
				{display: 'Название голосового сообщения', name: 'item_name', width: 508, sortable: false, align: 'left'},
				{display: 'Звуковые файлы фразы', name: 'item_voice', width: 100, sortable: false, align: 'left', hide: true}
			],
			buttons: [
				{name: 'Прослушать сообщение', cmd: 'bt_voices_play', bclass: 'btplay', onpress: voices_toolbar_cmd},
				{name: '&nbsp;', cmd: 'bt_voices_stop', bclass: 'btstop', onpress: voices_toolbar_cmd},
				{separator: true},
				{name: 'Обновить', cmd: 'bt_voices_refresh', bclass: 'btrefresh', onpress: voices_toolbar_cmd}
			],
			sortname: "item_name",
			sortorder: "asc",
			title: 'Список голосовых сообщений проекта',
			showToggleBtn: false,
			singleSelect: true,
			striped: true,
			novstripe: false,
			usepager: false,
			useRp: false,
			rp: 100,
			rpOptions: [10,25,50,100],
			showTableToggleBtn: false,
			width: 540,
			height: 75,
			resizable: false,
			errormsg: 'Список голосовых сообщений недоступен. Попробуйте позже.',
			pagestat: 'Отображены сообщения с {from} по {to} из {total}',
			pagetext: 'Страница',
			outof: 'из',
			findtext: 'Поиск&nbsp;',
			procmsg: 'Чтение...',
			rphint: 'Количество записей на странице',
			reloadhint: 'Обновить данные',
			nomsg: 'Редактирование отключено администратором проекта',
			autoload: false,
			preProcess: function(data) {
				if (data.total > 0)
					$('#projectprops_novoicemsg').hide();
				else
					$('#projectprops_novoicemsg').show();
				return data;
			},
			onSubmit: function() {
				$("#projectprops_voiceedit").parent().parent().hide();
				$("#projectprops_voiceedit > tbody").empty();
				$("#projectprops_voices").flexOptions({
					params: [
						{name: 'op', value: 'project_voices_list'},
						{name: 'pid', value: dialogprojectprops_prjid}
					]
				});
				return true;
			},
			onDblClick: function(row) {
				var recs = $(row).children('td');
				var voicelist = $(recs[1]).children('div').html();
				playVoice(voicelist, '', 'voiceplayer2');
			},
			onClick: function(row) {
				if (!$(row).hasClass('trSelected'))
					return true;
				var recs = $(row).children('td');
				var voicelist = $(recs[1]).children('div').text();
				voicelist = voicelist.replace(/^\s+|\s+$/g, '').split(',');
		        var tmpl_synthops =
				      '<a class="sy_play" rel="%SID%" title="Прослушать файл"><img src="images/flexigrid/play.png" width="16" height="16"></a>'
					+ '<a class="sy_del" rel="%SID%" title="Удалить файл из сообщения"><img src="images/flexigrid/del.png" width="16" height="16"></a>&nbsp;'
					+ '<a class="sy_up" rel="%SID%" title="Переместить файл выше по списку"><img src="images/flexigrid/upload.gif" width="16" height="16"></a>'
					+ '<a class="sy_dn" rel="%SID%" title="Переместить файл ниже по списку"><img src="images/flexigrid/download.gif" width="16" height="16"></a>';
				var datarows = new Array();
				$.each(voicelist, function(i, vc) {
					if (parseInt(vc) >= 0)
						datarows.push({id:vc, cell:[tmpl_synthops.replace(/%SID%/gi, vc), vc, (project_synthz_names[vc])?project_synthz_names[vc]:'<span class="warn">* ЗВУКОВОЙ ФАЙЛ НЕ НАЙДЕН!</span>']});
				});
				$("#projectprops_voiceedit").flexAddData({
					total: datarows.length,
					page: 1,
					rows: datarows
				});
				bind_synthops();
				$("#projectprops_voiceedit").parent().parent().fadeIn('fast');
			}
		});

		$("#projectprops_voiceedit").flexigrid({
			dataType: 'json',
			colModel: [
				{display: '&nbsp;', name: 'ops', width: 65, sortable: false, align: 'left'},
				{display: 'ID', name: 'id', width: 38, sortable: false, align: 'right'},
				{display: 'Название звукового файла', name: 'description', width: 380, sortable: false, align: 'left'}
			],
			buttons: [
				{name: 'Добавить файл >', cmd: 'bt_voiceedit_add', bclass: 'btadd', onpress: voiceedit_toolbar_cmd},
				{separator: true},
				{name: 'Сохранить изменения', cmd: 'bt_voiceedit_commit', bclass: 'btaccept', onpress: voiceedit_toolbar_cmd}/*,
				{name: 'Удалить файл', cmd: 'bt_voiceedit_del', bclass: 'btdel', onpress: voiceedit_toolbar_cmd},
				{separator: true},
				{name: 'Переместить выше', cmd: 'bt_voiceedit_up', bclass: 'btup', onpress: voiceedit_toolbar_cmd},
				{name: 'Переместить ниже', cmd: 'bt_voiceedit_dn', bclass: 'btdown', onpress: voiceedit_toolbar_cmd}*/
			],
			title: 'Звуковые файлы выбранного голосового сообщения',
			showToggleBtn: false,
			singleSelect: true,
			striped: false,
			novstripe: false,
			usepager: false,
			useRp: false,
			showTableToggleBtn: false,
			width: 540,
			height: 175,
			resizable: false,
			autoload: false
		});

		var processing_errors_cnt = 0;
		$('#projectprops_file_upload').uploadify({
			'uploader'  : 'uploadify.swf',
			'script'    : 'process',
			'cancelImg' : 'images/cancel.png',
			'fileExt'   : '*.wav;*.mp3',
			'fileDesc'  : 'Audio Files (*.wav, *.mp3)',
			'auto'      : false,
			'multi'     : true,
			'queueID'        : 'projectprops_upload_queue',
			'queueSizeLimit' : 100,
			'removeCompleted': false,
			'simUploadLimit' : 1,
			//'buttonText': 'Выберите файл для загрузки'
			'buttonImg' : 'images/btselectfilemu.gif',
			'width'     : 107,
			'height'    : 23,
			'wmode'     : 'transparent',
			'scriptAccess' : 'always',
			'onSelectOnce' : function(event, data) {
				processing_errors_cnt = 0;
				$('#projectprops_file_uploadprojectprops_result').text('Файлов добавлено в очередь: ' + data.filesSelected);
				$('#projectprops_file_upload').uploadifySettings('scriptData', {
					'op' : 'project_synthz_load',
					'pid' : dialogprojectprops_prjid,
					<?php echo "'cookie_hash':'" . base64_encode(http_build_query($_COOKIE, '', '&')) . "'"?>
				});
			},
			'onProgress' : function(event, ID, fileObj, data) {
				if (data.percentage == 100) {
					$('#' + $(event.target).attr('id') + ID).find('.percentage').text(' - Обработка...');
					$('#' + $(event.target).attr('id') + ID).find('.cancel').text('');
				}
			},
			'onComplete' : function(event, ID, fileObj, response, data) {
                $('#projectprops_result').html('Осталось обработать файлов: ' + data.fileCount);  //resobj.upload_result.status

                var upres = jQuery.parseJSON(response);
                var percobj = $('#' + $(event.target).attr('id') + ID).find('.percentage');
                if (upres.upload_result.status == 'error') {
                    processing_errors_cnt++;
                    $(percobj).html(' - ' + upres.upload_result.error);
                    $('#' + $(event.target).attr('id') + ID).addClass('uploadifyError');
                } else
                    $(percobj).html(' - Обработан. Идентификатор файла ' + upres.upload_result.fileid);
                //console.log($(percobj).html());
                return false;
            },
			'onAllComplete' : function(event, data) {
				$('#projectprops_result').text('Файлов загружено: ' + data.filesUploaded +
						', ошибок загрузки: ' + data.errors +
						', ошибок обработки: ' + processing_errors_cnt);
				if (data.filesUploaded > processing_errors_cnt)
					$("#projectprops_synthz").flexReload();
			},
			'onError' : function(event, ID, fileObj, errorObj) {
				console.log(errorObj.type + ' error: ' + errorObj.info);
			},
			'onInit' : function() {
				uploader_ready = true;
				return true;
			}
		});

		$("#dialogprojectprops ul.defskin").tabs("div.defskin > div", {
			onBeforeClick: function(event, tabIndex) {
				$('#projectprops_result').html('&nbsp;');
				$('#projectprops_msg').removeClass().empty();
				//hidePlayer();
				return true;
			}
		});

		$("#dialogprojectprops ul.subdefskin").tabs("div.subdefskin > div", {
			onBeforeClick: function(event, tabIndex) {
				$('#projectprops_result').html('&nbsp;');
				$('#projectprops_msg').removeClass().empty();
				//hidePlayer();
				return true;
			}
		});

		$("#projectprops_upload #queue_clear").click(function() {
			$('#projectprops_result').html('&nbsp;');
			if (uploader_ready) {
				try {
					$('#projectprops_file_upload').uploadifyClearQueue();
				} catch(err) {}
			}
			return false;
		});

		$("#projectprops_upload #queue_start").click(function() {
			$('#projectprops_result').html('&nbsp;');
			if (uploader_ready)
				$('#projectprops_file_upload').uploadifyUpload();
			return false;
		});

		$("#projectprops_synthz").parent().siblings('.tDiv').
			children(':last').css('clear', 'none').after('<div id="voiceplayer"></div>');
		$("#projectprops_voices").parent().siblings('.tDiv').
			children(':last').css('clear', 'none').after('<div id="voiceplayer2"></div>');
		AudioPlayer.setup("player.swf", {
			width: "255px",
			autostart: "no",
			animation: "no",
			remaining: "yes",
			noinfo: "no",
			buffer: 10,
			initialvolume: 30,
			transparentpagebg: "yes",
			//leftbg: "FFFFFF",
			//voltrack: "FFFFFF",
			//volslider: "FFFFFF",
			rightbg: "e5e5e5",
			rightbghover: "e5e5e5",
			righticon: "e5e5e5",
			righticonhover: "e5e5e5",
			//skip: "FFFFFF",
			//bg: "FFFFFF",
			left: "000000",
			lefticon: "FFFFFF"
		});
		AudioPlayer.embed("voiceplayer", {
			soundFile: "intro.mp3",
			artists: "Файл",
			titles: "не загружен",
			autostart: "no"
		});
		AudioPlayer.embed("voiceplayer2", {
			soundFile: "intro.mp3",
			artists: "Файл",
			titles: "не загружен",
			autostart: "no"
		});

		$('#bt_project_save').click(function() {
			var postdata = {
				op: 'project_params_save',
				pid: dialogprojectprops_prjid
			};
			postdata = $.param(postdata) + '&' + $('#tm_project_params .text').serialize();
			$('#projectparams_badbillingmsg').html('').hide();
			$(this).attr('disabled', 'disabled').addClass('disabled');
			$.ajax({
				type: 'POST',
				url: 'process',
				data: postdata,
				dataType: 'json',
				async: true,
				success: function(data) {
					if (data.error) {
						update_project_params();
						$('#projectparams_badbillingmsg').html(data.error).show();
					} else {
						$('#projectprops_msg').removeClass().empty();
						if (data.badbilling)
							$('#projectparams_badbillingmsg').html(data.badbilling).show();
						if (data.failcnt > 0)
							update_project_params();
						else
							$('#bt_project_save').removeAttr('disabled').removeClass('disabled');
						$("#projectprops_synthz").flexReload();
						$("#projectprops_voices").flexReload();
						$("#projectprops_upload #queue_clear").click();
					}
				}
			});
			return false;
		});

		//$("#projectprops_synthz").parents('.flexigrid').children('.tDiv').css('margin-bottom', '10px');
		$("#projectprops_voices").parents('.flexigrid').children('.hDiv').hide();
		$("#projectprops_voiceedit").parent().siblings('.tDiv')
			.find('#bt_voiceedit_add')
			.after('<select id="projectprops_voiceselect" title="Выберите файл в списке и нажмите Добавить файл"><option value="-1" selected>...список загружается...</option></select>');
	});
</script>
<div class="close"></div>
<div id="dlg_caption">Параметры проекта</div>
<div id="settings_form">
	<ul class="settings-tabs defskin">
		<li><a href="#">Настройки</a></li>
		<li><a href="#">Голосовые сообщения</a></li>
	</ul>
	<div class="settings-panes defskin">
		<div>
			<fieldset id="tm_project_params">
				<p>
					<label for="tm_project_auth_type">Тип авторизации</label>
					<select name="tm_project_auth_type" id="tm_project_auth_type" class="text">
						<option value="" selected>&lt; Не задан &gt;</option>
						<option value="1">По номеру телефона</option>
						<option value="2">По ПИН-коду</option>
						<option value="3">По номеру счета</option>
						<option value="4">Безлимит</option>
					</select>
				</p>
				<p>
					<label for="tm_project_auth_id">Параметр авторизации (ПИН-код, телефон, ...)</label>
					<input type="text" name="tm_project_auth_id" id="tm_project_auth_id" class="text" value="" />
				</p>
				<p>
					<label for="tm_project_task_max">Максимальное количество одновременных задач</label>
					<input type="text" name="tm_project_task_max" id="tm_project_task_max" class="text" value="" />
				</p>
				<p>
					<label for="tm_project_dial_count">Число попыток повтора выполнения задач</label>
					<input type="text" name="tm_project_dial_count" id="tm_project_dial_count" class="text" value="" />
				</p>
				<p>
					<label for="tm_project_menuid">IVR-Схема проекта</label>
					<select name="tm_project_menuid" id="tm_project_menuid" class="text"></select>
				</p>
			</fieldset>
			<fieldset>
				<p>
					<input type="image" class="button" id="bt_project_save" title="Применить изменения" src="images/btapply.gif"/>
				</p>
			</fieldset>
			<div id="projectparams_badbillingmsg" class="authmessagetext" style="display:none"></div>
		</div>
		<div>
			<ul class="settings-tabs subdefskin">
				<li><a href="#">Редактирование</a></li>
				<li><a href="#">Звуковые файлы</a></li>
				<li><a href="#">Загрузка звуковых файлов</a></li>
			</ul>
			<div class="settings-panes subdefskin">
				<div>
					<table id="projectprops_voices" style="display:none"></table>
					<div class="spacer10"></div>
					<table id="projectprops_voiceedit" style="display:none"></table>
					<div id="projectprops_novoicemsg" class="authmessagetext" style="display:none">Список голосовых сообщений не настроен администратором проекта.</div>
				</div>
				<div>
					<table id="projectprops_synthz" style="display:none"></table>
				</div>
				<div>
					<div id="projectprops_upload">
					<!-- <div>Выберите один или несколько звуковых файлов для загрузки в проект:</div> -->
						<input id="projectprops_file_upload" name="projectprops_file_upload" type="file"/>
						<a id="queue_start">Загрузить</a><a id="queue_clear">Очистить очередь</a>
						<div class="spacer0"></div>
						<div id="projectprops_upload_queue"></div>
					</div>
					<div id="projectprops_result">&nbsp;</div>
				</div>
			</div>
		</div>
	</div>
</div>
<div id="projectprops_msg"></div>
<script type="text/javascript">
	<!--
	if (!IsFlashEnabled())
		writeGetFlashImage();
	// -->
</script>
