<?php
/**
 * widget_projectstat.php
 */
require_once(dirname(__FILE__) . '/include/session.php');

global $session, $database;
if (!$session->db_ok) {
	print('database not ok');
	die();
}

$session->initStatFilters();
?>

<script type="text/javascript">

var curProjId = null;
function updateProjStats(projid) {
	curProjId = projid;

	$("#projstats>tbody").empty();

	$('#sf_projsnapshot option').remove();
	$('#projsnapshot option').clone().appendTo('#sf_projsnapshot');
	$('#sf_projsnapshot option:last').remove();
	if ($('#projsnapshot').val() != '0')
		$('#sf_projsnapshot').val($('#projsnapshot').val());
	else
		$('#sf_projsnapshot option:last').attr('selected', 'selected');
	$('#sf_projsnapshot').trigger('change');

	//$("#projstats").flexReload();

	$('#bt_projstats_billing_refresh').click();
	$("#projstats_calls").flexReload();
	$("#projstats_pays").flexReload();
}

if (!Number.toFixed) {
	Number.prototype.toFixed = function(n) {
		return Math.round(this * Math.pow(10, n)) / Math.pow(10, n);
	}
}

$(document).ready(function() {
	$('#dialogprojectstat').overlay().load();

	$('#dialogprojectstat .close').click(function() {
		$(this).parent().overlay().close();
		return false;
	});

	/*$('.dateselector').datePicker({
		clickInput: false
	}).dpSetStartDate('10.08.2001');

	$('#sf_startdate_proj').dpSetSelected('<?php //echo $session->sf_startdate_proj; ?>');
	$('#sf_enddate_proj').dpSetSelected('<?php //echo $session->sf_enddate_proj; ?>');

	$('.fs_date').click(function() {
		FilterSetDateInterval($(this).attr('rel'), 'sf_startdate_proj', 'sf_enddate_proj');
		return false;
	});*/

	$("#projstats").flexigrid({
		url: 'process',
		params: [{name: 'op', value: 'project_stats'}],
		dataType: 'json',
		colModel: [
			{display: '&nbsp;', name: 'flags', width: 14, align: 'right'},
			{display: 'Номер', name: 'tm_task_dial_num', width: 64, align: 'right'},
			{display: 'Статус задачи', name: 'tm_task_status', width: 180, align: 'right'},
			{display: 'Статус дозвона', name: 'tm_task_dial_cause', width: 180, align: 'right'},
			{display: 'Результат', name: 'tm_task_result', width: 180, align: 'right'},
			{display: 'Подтверждение', name: 'tm_task_result_confirm', width: 80, align: 'right'},
			{display: 'Кол-во попыток', name: 'tm_task_try_count', width: 80, align: 'right'},
			{display: 'Дата', name: 'tm_task_last_time', width: 100, align: 'right'},
			{display: 'Продолжительность', name: 'tm_task_total_time', width: 105, align: 'right'}
			],
		sortname: "tm_task_last_time",
		sortorder: "desc",
		title: false,
		showToggleBtn: false,
		singleSelect: true,
		striped: true,
		usepager: true,
		useRp: true,
		rp: 50,
		rpOptions: [10,50,100,150,200,500,1000],
		showTableToggleBtn: false,
		width: 'auto',
		height: 253,
		resizable: false,
		errormsg: 'Статистика в данный момент недоступна. Попробуйте позже.',
		pagestat: 'Отображены записи с {from} по {to} из {total}',
		pagetext: 'Страница',
		outof: 'из',
		findtext: 'Поиск&nbsp;',
		procmsg: 'Чтение...',
		rphint: 'Количество записей на странице',
		reloadhint: 'Обновить данные',
		nomsg: 'Нет записей',
		autoload: false,
		onSubmit: function() {
			$('#historypay_filters input[type="image"]').attr('disabled', 'disabled').addClass('disabled');

			timer_projects_stop();

			$("#projstats").flexOptions({
				params: [
					{name: 'op', value: 'project_stats'},
					{name: 'pid', value: curProjId},
					//{name: 'sf_startdate_proj', value: $('#sf_startdate_proj').val()},
					//{name: 'sf_enddate_proj', value: $('#sf_enddate_proj').val()},
					{name: 'sf_projsnapshot', value: $('#sf_projsnapshot').val()},
					{name: 'flagsin', value: ''}
				]
			});

			var gparams = $.param([
				{name: 'pid', value: curProjId},
				//{name: 'starttm', value: $('#sf_startdate_proj').val()},
				//{name: 'stoptm', value: $('#sf_enddate_proj').val()},
				{name: 'sf_projsnapshot', value: $('#sf_projsnapshot').val()},
				{name: 'flagsin', value: ''}
			]);
			$('#projstats_graph_detail').html('Загрузка...').
				load('graph_projstats?gtype=detail&' + gparams);
			$('#projstats_graph_stats').html('Загрузка...').
				load('graph_projstats?gtype=stats&' + gparams);
			return true;
		},
		onError: function(XMLHttpRequest, textStatus, errorThrown) {
			$('#historypay_filters input[type="image"]').removeAttr('disabled').removeClass('disabled');
			return true;
		},
		onSuccess: function() {
			$('#historypay_filters input[type="image"]').removeAttr('disabled').removeClass('disabled');
			return true;
		},
		preProcess: function(data) {
			var tmtabs = $("#projstats_tm_tabs").data('tabs');
			if (data.total) {
				$('#historypay_filters input[type="image"]').removeAttr('disabled').removeClass('disabled');
				tmtabs.getTabs().eq(1).show();
				tmtabs.getTabs().eq(2).show();
			} else {
				tmtabs.click(0);
				tmtabs.getTabs().eq(1).hide();
				tmtabs.getTabs().eq(2).hide();
			}
			return data;
		}
	});

	$("#projstats_calls").flexigrid({
		url: 'process',
		params: [{name: 'op', value: 'project_stats_calls'}],
		dataType: 'json',
		colModel: [
			{display: '', name: 'flagsout', width: 16, align: 'right'},
			{display: 'Дата', name: 'creattime', width: 100, align: 'left'},
			{display: 'Вызывающий', name: 'numbera', width: 80, align: 'right'},
			{display: 'Вызываемый', name: 'numberb', width: 80, align: 'right'},
			{display: 'Стоимость', name: 'pay', width: 60, align: 'right'},
			{display: 'Длительность', name: 'payablevolume', width: 75, align: 'right'},
			{display: 'Направление', name: 'geographyname', width: 290, align: 'left'}
			],
		sortname: "creattime",
		sortorder: "desc",
		title: false,
		showToggleBtn: false,
		singleSelect: true,
		striped: false,
		usepager: true,
		useRp: true,
		rp: 50,
		rpOptions: [10,20,25,30,50,100],
		showTableToggleBtn: false,
		width: 'auto',
		height: 300,
		resizable: false,
		errormsg: 'История в данный момент недоступна. Попробуйте позже.',
		pagestat: 'Отображены записи с {from} по {to} из {total}',
		pagetext: 'Страница',
		outof: 'из',
		findtext: 'Поиск&nbsp;',
		procmsg: 'Чтение...',
		nomsg: 'Нет записей',
		autoload: false,
		onSubmit: function() {
			$("#projstats_calls").flexOptions({
				params: [
					{name: 'op', value: 'project_stats_calls'},
					{name: 'pid', value: curProjId}
				]
			});
			return true;
		}
	});

	$("#projstats_pays").flexigrid({
		url: 'process',
		params: [{name: 'op', value: 'project_stats_pays'}],
		dataType: 'json',
		colModel: [
			{display: 'Дата', name: 'paydate', width: 100, align: 'right'},
			{display: 'Сумма', name: 'paysumm', width: 60, align: 'right'},
			{display: 'Описание', name: 'payinfo', width: 375, align: 'left'},
			{display: 'Источник', name: 'paysrc', width: 85, align: 'left'}
			],
		sortname: "paydate",
		sortorder: "desc",
		title: false,
		showToggleBtn: false,
		singleSelect: true,
		striped: false,
		usepager: true,
		useRp: true,
		rp: 50,
		rpOptions: [10,20,25,30,50,100],
		showTableToggleBtn: false,
		width: 'auto',
		height: 300,
		resizable: false,
		errormsg: 'История в данный момент недоступна. Попробуйте позже.',
		pagestat: 'Отображены записи с {from} по {to} из {total}',
		pagetext: 'Страница',
		outof: 'из',
		findtext: 'Поиск&nbsp;',
		procmsg: 'Чтение...',
		nomsg: 'Нет записей',
		autoload: false,
		preProcess: function(data) {
			var totalp = 0.0, totalm = 0.0, totalpc = 0, totalmc = 0;
			$.each(
				data.rows,
				function(i, row) {
					if (parseFloat(row.cell[1]) > 0) {
						totalpc++;
						totalp += parseFloat(row.cell[1]);
					} else {
						totalmc++;
						totalm += parseFloat(row.cell[1]);
					}
			});
			if (totalpc > 0 || totalmc > 0)
				$('#projstats_pays_totals')
					.html('Итого: пополнений '+totalpc+' на сумму '+totalp.toFixed(2)+', списаний '+totalmc+' на сумму '+Math.abs(totalm.toFixed(2)))
					.show();
			return data;
		},
		onSubmit: function() {
			$('#projstats_pays_totals')
				.html('')
				.hide();
			$("#projstats_pays").flexOptions({
				params: [
					{name: 'op', value: 'project_stats_pays'},
					{name: 'pid', value: curProjId}
				]
			});
			return true;
		}
	});

	$("#dialogprojectstat ul.defskin").tabs("div.defskin > div");
	$("#dialogprojectstat ul.subdefskin").tabs("div.subdefskin > div");

	$('#bt_hc_apply').click(function() {
		/*if ($('#sf_startdate_proj').val().length < 1) {
			$('#projstatsmessage').removeClass().addClass('authmessagetext').html('Не задана начальная дата!');
			$('#sf_startdate_proj').focus();
			return false;
		}
		if ($('#sf_enddate_proj').val().length < 1) {
			$('#projstatsmessage').removeClass().addClass('authmessagetext').html('Не задана конечная дата!');
			$('#sf_enddate_proj').focus();
			return false;
		}*/

		$("#projstats").flexReload();
		/*$('#bt_hc_apply').attr('disabled', 'disabled').addClass('disabled');
		$.ajax({
			type: 'POST',
			url: 'process',
			data: ({op: 'project_filters_set',
				sf_startdate_proj: $('#sf_startdate_proj').val(),
				sf_enddate_proj: $('#sf_enddate_proj').val()
			}),
			dataType: 'json',
			async: true,
			success: function(data) {
				$("#projstats").flexReload();
				$('#bt_hc_apply').removeAttr('disabled').removeClass('disabled');
			}
		});*/
		return false;
	});

	$('#bt_hc_save_xls').click(function() {
		/*if ($('#sf_startdate_proj').val().length < 1) {
			$('#projstatsmessage').removeClass().addClass('authmessagetext').html('Не задана начальная дата!');
			$('#sf_startdate_proj').focus();
			return false;
		}
		if ($('#sf_enddate_proj').val().length < 1) {
			$('#projstatsmessage').removeClass().addClass('authmessagetext').html('Не задана конечная дата!');
			$('#sf_enddate_proj').focus();
			return false;
		}*/

		$('#bt_hc_save_xls').attr('disabled', 'disabled').addClass('disabled');
		$.download('process', {
			op: 'project_stats_xml',
			pid: curProjId,
			//sf_startdate_proj: $('#sf_startdate_proj').val(),
			//sf_enddate_proj: $('#sf_enddate_proj').val(),
			sf_projsnapshot: $('#sf_projsnapshot').val(),
			sortname: 'tm_task_last_time',
			sortorder: 'desc'
		});
		$('#bt_hc_save_xls').removeAttr('disabled').removeClass('disabled');
		return false;
	});

	/*$('#sf_startdate_proj').keypress(function(e) {
		if (e.which == 13 && $(this).val().length > 0)
			$('#sf_enddate_proj').trigger('focus');
		return true;
	});

	$('#sf_enddate_proj').keypress(function(e) {
		if (e.which == 13 && $(this).val().length > 0) {
			$('#bt_hc_apply').click();
			return false;
		}
		return true;
	});*/

	$('#sf_projsnapshot').change(function () {
		$(this).blur();
		$("#projstats").flexReload();
	}).keypress(function(e) {
		if (e.which == 13 && $(this).val().length > 0) {
			$(this).trigger('change');
			return false;
		}
		return true;
	});

	$('#bt_projstats_billing_refresh').click(function() {
		$('#projstats_noaccountmsg').hide();
		$('#projstats_billing_info_btns input[type="image"]').attr('disabled', 'disabled').addClass('disabled');
		$('#projstats_billing_info_cont .text').attr('disabled', 'disabled').val('').css('background','#fff url("images/loading-dots.gif") no-repeat center center');
		$.ajax({
			type: 'POST',
			url: 'process',
			data: ({
				op: 'project_stats_billinfo',
				pid: curProjId
			}),
			dataType: 'json',
			async: true,
			success: function(data) {
				$('#projstats_billing_info_cont .text').css('background','#fff');
				var biltabs = $("#projstats_billing_tabs").data('tabs');
				biltabs.click(0);
				if (data.error) {
					$('#projstats_noaccountmsg').html(data.error).show();//.siblings().hide();
					biltabs.getTabs().eq(1).hide();
					biltabs.getTabs().eq(2).hide();
				} else {
					//$('#projstats_noaccountmsg').siblings().show();
					biltabs.getTabs().eq(1).show();
					biltabs.getTabs().eq(2).show();

					$.each(data.params, function(pname, pvalue) {
						var inp = $('#projstats_billing_info_' + pname);
						if (inp)
							inp.val(pvalue);
					});
				}
				$('#projstats_billing_info_btns input[type="image"]').removeAttr('disabled').removeClass('disabled');
			}
		});
		return false;
	});

});
</script>

<div class="close"></div>
<div id="dlg_caption">Статистика по проекту</div>
<div id="settings_form">
	<ul class="settings-tabs defskin">
		<li><a href="#">История выполнения</a></li>
		<li><a href="#">Биллинг</a></li>
	</ul>
	<div class="settings-panes defskin">
		<div>
			<ul id="projstats_tm_tabs" class="settings-tabs subdefskin">
				<li><a href="#">Данные</a></li>
				<li><a href="#">Детализация</a></li>
				<li><a href="#">Статистика</a></li>
			</ul>
			<div class="settings-panes subdefskin">
				<div>
					<div id="historypay_filters">
						<fieldset class="tiny">
							<p>
								<!-- <label for="sf_startdate_proj">Дата&nbsp;с</label>
								<input type="text" name="sf_startdate_proj" id="sf_startdate_proj" class="text dateselector" />
								<label for="sf_enddate_proj">по</label>
								<input type="text" name="sf_enddate_proj" id="sf_enddate_proj" class="text dateselector" /> -->
								<label for="sf_projsnapshot">Период&nbsp;</label>
								<select name="sf_projsnapshot" id="sf_projsnapshot" class="text" title="Список периодов работы проекта"></select>
								<!-- <input type="image" class="button" id="bt_hc_apply" value="Применить" src="images/btapply.gif"/> -->
								<input type="image" class="button" id="bt_hc_save_xls" value="Сохранить в Excel" src="images/btn_save_xls.gif"/>
								<!-- <div class="linkspacer"></div>
								<a class="filtersetter first fs_date" rel="d" title="За день">день</a>
								<a class="filtersetter fs_date" rel="w" title="За неделю">неделя</a>
								<a class="filtersetter fs_date" rel="m" title="За месяц">месяц</a>
								<a class="filtersetter fs_date" rel="2m" title="За два месяца">2 месяца</a>
								<a class="filtersetter fs_date" rel="05y" title="За полгода">полгода</a>
								<a class="filtersetter fs_date" rel="y" title="За год">год</a> -->
						</fieldset>
					</div>
					<div id="projstats_form">
						<div class="spacer10"></div>
						<table id="projstats" style="display:none"></table>
					</div>
				</div>
				<div>
					<div id="projstats_graph_detail"></div>
				</div>
				<div>
					<div id="projstats_graph_stats"></div>
				</div>
			</div>
		</div>
		<div>
			<ul id="projstats_billing_tabs" class="settings-tabs subdefskin">
				<li><a href="#">Состояние счета</a></li>
				<li><a href="#">История услуг</a></li>
				<li><a href="#">История платежей</a></li>
			</ul>
			<div class="settings-panes subdefskin">
				<div>
					<fieldset id="projstats_billing_info_cont" class="narrow">
						<p>
							<label for="projstats_billing_info_createdate">Дата создания счета</label>
							<input type="text" name="projstats_billing_info_createdate" id="projstats_billing_info_createdate" class="text" value="" />
						</p>
						<p>
							<label for="projstats_billing_info_fio">Имя владельца</label>
							<input type="text" name="projstats_billing_info_fio" id="projstats_billing_info_fio" class="text" value="" />
						</p>
						<p>
							<label for="projstats_billing_info_currencyname">Валюта</label>
							<input type="text" name="projstats_billing_info_currencyname" id="projstats_billing_info_currencyname" class="text" value="" />
						</p>
						<p>
							<label for="projstats_billing_info_summ">Сумма на счете</label>
							<input type="text" name="projstats_billing_info_summ" id="projstats_billing_info_summ" class="text" value="" />
						</p>
					</fieldset>
					<fieldset id="projstats_billing_info_btns" class="narrow">
						<p>
							<input type="image" class="button" id="bt_projstats_billing_refresh" title="Обновить состояние" src="images/btrefresh.gif"/>
						</p>
					</fieldset>
					<div id="projstats_noaccountmsg" class="authmessagetext"></div>
				</div>
				<div>
					<table id="projstats_calls" style="display:none"></table>
				</div>
				<div>
					<table id="projstats_pays" style="display:none"></table>
					<div id="projstats_pays_totals" class="totals" style="display:none"></div>
				</div>
			</div>
		</div>
	</div>
</div>
<div id="projstatsmessage"></div>
