<?php
require_once(dirname(__FILE__) . '/include/session.php');

global $session, $database;
if (!$session->db_ok) {
	print('database not ok');
	die();
}
?>

<script type="text/javascript">
	var dialogtaskprops_taskid = null;

	function update_task_params() {
		$('#bt_task_refresh').click();
		return false;
	}

	function updateTaskProps(taskID) {
		var doreload = (dialogtaskprops_taskid != taskID);
		dialogtaskprops_taskid = taskID;
		if (doreload)
			update_task_params();
	}

	var force_tasks_update = false;
	$(document).ready(function() {
		$('#dialogtaskprops').overlay().load();

		$('#dialogtaskprops .close').click(function() {
			$(this).parent().overlay().close();
			return false;
		});

		$('#dialogtaskprops').bind('onClose', function(event) {
			if (force_tasks_update)
			  $("#projtasks").flexReload();
		});

		$("ul.defskin").tabs("div.defskin > div", {
			onBeforeClick: function(event, tabIndex) {
				$('#taskprops_msg').removeClass().empty();
				return true;
			}
		});

		$('#bt_task_refresh').click(function() {
			$('#bt_task_refresh, #bt_task_save').attr('disabled', 'disabled').addClass('disabled');
			$('#tm_task_params_cont .text').val('').css('background','#fff url("images/loading-dots.gif") no-repeat center center');
			$.ajax({
				type: 'POST',
				url: 'process',
				data: ({
					op: 'task_params_list',
					tid: dialogtaskprops_taskid
				}),
				dataType: 'json',
				async: true,
				success: function(data) {
					$('#tm_task_params_cont .text').css('background','#fff');
					if (data.error) {
						alert(data.error);
					} else {
						$.each(data.params, function(pname, pvalue){
							$('#' + pname).val(pvalue);
						});
					}
					$('#bt_task_refresh, #bt_task_save').removeAttr('disabled').removeClass('disabled');
				}
			});
			return false;
		});

		$('#bt_task_save').click(function() {
			var postdata = {
				op: 'task_params_save',
				tid: dialogtaskprops_taskid
			};
			postdata = $.param(postdata) + '&' + $('#tm_task_params_cont .text').serialize();
			$('#bt_task_refresh, #bt_task_save').attr('disabled', 'disabled').addClass('disabled');
			$.ajax({
				type: 'POST',
				url: 'process',
				data: postdata,
				dataType: 'json',
				async: true,
				success: function(data) {
					if (data.error) {
						update_task_params();
						alert(data.error);
					} else {
						$('#projectprops_msg').removeClass().empty();
						if (data.failcnt > 0)
							update_task_params();
						else
							$('#bt_task_refresh, #bt_task_save').removeAttr('disabled').removeClass('disabled');
						force_tasks_update = true;
					}
				}
			});
			return false;
		});

	});
</script>
<div class="close"></div>
<div id="dlg_caption">Параметры задачи</div>
<div id="settings_form">
	<ul class="settings-tabs defskin">
		<li><a href="#">Базовые параметры</a></li>
	</ul>
	<div class="settings-panes defskin">
		<div>
			<fieldset id="tm_task_params_cont">
				<p>
					<label for="tm_task_status">Статус задачи</label>
					<select name="tm_task_status" id="tm_task_status" class="text">
						<option value="" selected></option>
						<option value="0">Готова к выполнению</option>
						<option value="1">Ожидание набора номера</option>
						<option value="2">Набор номера</option>
						<option value="3">Пауза перед очередной попыткой набора</option>
						<option value="4">Системная ошибка при дозвоне</option>
						<option value="100">Завершена</option>
						<option value="101">Достигнут лимит попыток дозвона</option>
						<option value="102">Отмечена администратором как завершенная</option>
					</select>
				</p>
				<p>
					<label for="tm_task_dial_num">Номер телефона для дозвона</label>
					<input type="text" name="tm_task_dial_num" id="tm_task_dial_num" class="text" value="" />
				</p>
				<p>
					<label for="tm_task_auth_id">Параметр авторизации (ПИН-код, телефон, ...)</label>
					<input type="text" name="tm_task_auth_id" id="tm_task_auth_id" class="text" value="" />
				</p>
				<p>
					<label for="tm_task_params">Дополнительные параметры</label>
					<textarea name="tm_task_params" id="tm_task_params" class="text" rows="10" cols="250"></textarea>
				</p>
			</fieldset>
			<fieldset>
				<p>
					<input type="image" class="button" id="bt_task_save" title="Применить изменения" src="images/btapply.gif"/>
					<input type="image" class="button" id="bt_task_refresh" title="Получить актуальные значения параметров" src="images/btrefresh.gif"/>
				</p>
			</fieldset>
		</div>
	</div>
</div>
<div id="taskprops_msg"></div>
