<?php
/**
 * widget_tasksload.php
 */
require_once(dirname(__FILE__) . '/include/session.php');

global $session, $database;
if (!$session->db_ok) {
	print('database not ok');
	die();
}

$session->initStatFilters();
?>

<script type="text/javascript">
	var dialogtasksload_prjid = null;
	function updateTasksLoad(projID) {
		dialogtasksload_prjid = projID;
	}

	var force_tasks_update = false;
	$(document).ready(function() {
		$('#dialogtasksload').overlay().load();

		$('#dialogtasksload .close').click(function() {
			$(this).parent().overlay().close();
			return false;
		});

		$('#dialogtasksload').bind('onClose', function(event) {
			$('#tasksload_result').empty();
			$('#tasksload_file_upload').uploadifyClearQueue();
			if (force_tasks_update)
			  $("#projtasks").flexReload();
		});

		$('#tasksload_file_upload').uploadify({
			'uploader'  : 'uploadify.swf',
			'script'    : 'process',
			'cancelImg' : 'images/cancel.png',
			'folder'    : 'uploads',
			'fileExt'   : '*.txt;*.csv',
			'fileDesc'  : 'Text Files (*.txt, *.csv)',
			'auto'      : true,
			//'buttonText': 'Выберите файл для загрузки'
			'buttonImg' : 'images/btselectfile.gif',
			'width'     : 97,
			'height'    : 23,
			'wmode'     : 'transparent',
			'scriptAccess' : 'always',
			'onSelectOnce' : function(event, data) {
				$('#tasksload_file_upload').uploadifySettings('scriptData', {
					'op' : 'project_tasks_load',
					'pid' : dialogtasksload_prjid,
					<?php echo "'cookie_hash':'" . base64_encode(http_build_query($_COOKIE, '', '&')) . "'"?>
				});
			},
			'onComplete'  : function(event, ID, fileObj, response, data) {
				//alert(response);
				var obj = jQuery.parseJSON(response);
				//console.log(obj.result[0].rows);
				if (obj.error)
					$('#tasksload_result').html(
						'<br />' + obj.error);
				else
					$('#tasksload_result').html(
						'<br />' +
						'Обработано записей: ' + obj.result[0].rows + '<br />' +
						'Успешно внесено: ' + obj.result[0].success + '<br />' +
						'Обновлений: ' + obj.result[0].updated + '<br />' +
						'Добавлений: ' + obj.result[0].inserted + '<br />' +
						'Всего ошибок: ' + (obj.result[0].rows - obj.result[0].success) + '<br />' +
						'Ошибок контроля внешнего индекса: ' + obj.result[0].wr_ext_id + '<br />'
					);
				//alert(obj.result[0].rows);
				if (obj.result[0].success > 0)
					force_tasks_update = true;
			},
			'onError' : function(event, ID, fileObj, errorObj) {
				console.log(errorObj.type + ' error: ' + errorObj.info);
			}
		});
		return true;
	});
</script>
<div class="close"></div>
<div id="dlg_caption">Загрузка задач в проект</div>
<div id="tasksload_upload">
	<input id="tasksload_file_upload" name="tasksload_file_upload" type="file"/>
</div>
<div id="tasksload_result"></div>
