<?php
/**
 * widget_taskstats.php
 */
require_once(dirname(__FILE__) . '/include/session.php');

global $session, $database;
if (!$session->db_ok) {
	print('database not ok');
	die();
}

$session->initStatFilters();
?>

<script type="text/javascript">
	var dialogtaskstats_taskid = null;
	function updateTaskStats(taskid) {
		dialogtaskstats_taskid = taskid;
		$("#taskstats>tbody").empty();
		$("#taskstats").flexReload();
	}

	$(document).ready(function() {
		$('#dialogtaskstats').overlay().load();

		$('#dialogtaskstats .close').click(function() {
			$(this).parent().overlay().close();
			return false;
		});

		$("#taskstats").flexigrid({
			url: 'process',
			params: [
				{name: 'op', value: 'task_stats'}
			],
			dataType: 'json',
			colModel: [
				{display: '&nbsp;', name: 'flags', width: 14, sortable: false, align: 'right'},
				{display: 'Дата и время', name: 'tm_task_start_time', width: 100, sortable: false, align: 'right'},
				{display: 'Статус задачи', name: 'tm_task_status', width: 280, sortable: false, align: 'right'},
				{display: 'Статус дозвона', name: 'tm_task_dial_status', width: 280, sortable: false, align: 'right'}
			],
			sortname: "tm_task_start_time",
			sortorder: "desc",
			title: false,
			showToggleBtn: false,
			singleSelect: true,
			striped: true,
			usepager: true,
			useRp: true,
			rp: 500,
			rpOptions: [10,50,100,150,200,500,1000],
			showTableToggleBtn: false,
			width: 'auto',
			height: 350,
			resizable: false,
			errormsg: 'История в данный момент недоступна. Попробуйте позже.',
			pagestat: 'Отображены записи с {from} по {to} из {total}',
			pagetext: 'Страница',
			outof: 'из',
			findtext: 'Поиск&nbsp;',
			procmsg: 'Чтение...',
			rphint: 'Количество записей на странице',
			reloadhint: 'Обновить данные',
			nomsg: 'Нет записей',
			autoload: false,
			onSubmit: function() {
				timer_projects_stop();

				$("#taskstats").flexOptions({
					params: [
						{name: 'op', value: 'task_stats'},
						{name: 'tid', value: dialogtaskstats_taskid}
					]
				});
				return true;
			}
		});
	});
</script>

<div class="close"></div>
<div id="dlg_caption">История выполнения задачи</div>
<div id="taskstats_form">
	<div class="spacer10"></div>
	<table id="taskstats" style="display:none"></table>
	<div class="spacer10"></div>
</div>
<div id="taskstatsmessage"></div>
